 7.10.2
	- The qm translation files will no longer be included in the FET sources package (suggested by Michael Towers).
	- The activities and the subactivities dialogs have new tristate check boxes, "Unique", for teachers/students/activity tags
	(suggested by Vangelis Karafillidis). Their use is explained in the dialog's Help function.
	- It is now possible to import the teachers' qualifications from the activities list (suggested by GUEFFAZ REDA).
	- The constraints of type teacher home room(s) will now show the teacher's mornings/afternoons behavior (in the Mornings-Afternoons
	mode), and the associated constraint of type teacher not available times for that teacher (suggested by YOUSSEF HOUIET).
	- The modify activity and modify subactivity dialogs now have a filter for teachers/students sets/activity tags, similar
	to the add activity dialog (suggested by GUEFFAZ REDA).
	- The search in menu line edit has now an explanation (suggested by Michael Towers).
	- Corrected and improved many English text fields, by Volker Dirr, using ChatGPT.
	- Corrected the Romanian translation, by Liviu Lalescu, as suggested by Volker Dirr, who found some errors using ChatGPT.
	- Corrected the Greek translation, by Vangelis Karafillidis, as suggested by Volker Dirr, who found some errors using ChatGPT.
	- Corrected the Uzbek translation, by Ulugbek Tulakov, as suggested by Volker Dirr, who found some errors using ChatGPT.
	- Corrected the French translation, by Pascal Cohen, as suggested by Volker Dirr, who found some errors using ChatGPT.
	- Corrected the Brazilian Portuguese translation, by Alexandre R. Soares, as suggested by Volker Dirr, who found some errors
	using ChatGPT.
	- Corrected the Italian translation, by Andrea Primiani, as suggested by Volker Dirr, who found some errors using ChatGPT.
	- Corrected the Arabic translation, by Benahmed Abdelkrim, as suggested by Volker Dirr, who found some errors using ChatGPT.
	- Minor other corrections and improvements.
 7.10.1
	- Updated to Qt 6.11.2.
	- Added a 'Quick search' line edit for the menu items (suggested by Syed, and maybe also by other users in the past). This feature
	is optional (enabled by default), and can be disabled from the Settings menu.
	- In the dialog of the constraints activities preferred time slots related to a selection of activities in the view timetable dialogs,
	the user can now add multiple constraints, one for each filtered activity, with a single click (suggested by Vangelis Karafillidis).
	- Updated the Italian translation, by Andrea Primiani.
 7.10.0
	- Bug fix, when using constraints of type building min one activity in each available time slot (found by Volker Dirr, using
	ChatGPT).
	- Crash bug fix, if a constraint max days between each pair of consecutive activities had max days = 0 (found by Volker Dirr,
	using ChatGPT).
	- Bug fix, when using constraints of type room(s) max activities per teacher, and when some activities had multiple teachers
	(discovered by Volker Dirr, using ChatCPT). The bug made the algorithm reject some correct solutions.
	- Generation bug fix in the constraints of type building min one activity in each available time slot, if the data file contained
	activities with duration greater than 1.
	- Added an option to save the data and timetable for a selection of days as a new file, after generating a timetable (suggested by
	Vangelis Karafillidis). The activities placed in the unselected days will be deactivated. For this new feature, some new English
	text fields were suggested by Vangelis Karafillidis.
	- Added 'teachers not available'/'activities preferred time slots' constraints' import/export from/to a CSV file (suggested by
	Vangelis Karafillidis, Fritzlang, TongThanhKieu, Steffen Schiedek, and maybe by other users in the past). For this new feature,
	some new English text fields were suggested by Vangelis Karafillidis.
	- It is now possible to lock/unlock the timetable for a selection of days, not only for a single day at a time (suggested by
	YOUSSEF HOUIET).
	- Minor improvement: we now check that the number of students of a students set is greater or equal to zero when reading a data file
	(potential bug reported by Yush Yuen). Also, if the number of students is specified for an activity, we also check that it is greater
	or equal to zero.
	- Minor improvement: if an activity has a specified number of students, the fet data file will contain the field 'Number_of_Students'
	instead of 'Number_Of_Students', to use the same capitalization as the corresponding years', groups', and subgroups' fields.
	- Minor improvement: the 'Generate multiple' menu item is now placed immediately under the 'Generate new' menu item, and before
	the 'View' menu items.
	- Interface improvement: in the constraints with a table of spin boxes (constraints of type teacher(s)/students (set)/room(s)/activities
	occupy max sets of time slots from selection), the tab key now moves vertically instead of horizontally (suggested by YOUSSEF HOUIET).
	- Other corrections and improvements (found by Volker Dirr, using ChatGPT).
 7.9.5
	- Added simple filters of type 'Contains text (case insensitive)' for the lists of teachers, students, and activity tags, in the Add
	activity dialog (suggested by gerben).
	- Added an option to embed the CSS code in the HTML files (suggested by Volker Dirr). In this way, some programs will import better the
	HTML timetables.
	- Minor interface bug fix (reported by poetasandaluces): for the constraints of type (sub)activities preferred starting times/time slots
	and activities begin/end/begin or end teachers'/students' day which did not affect any activity, FET reported an error in the data file;
	but this was simply a useless constraint (but FET still won't begin the generation in such a case, and you need to modify/deactivate/remove
	these useless constraints - just that the information message is now clearer and not so alarming).
	- Added a new Uzbek translation, by Ulugbek Tulakov, who is the new translator (he was assisted by AI).
 7.9.4
	- Crash bugs fixed, when using a filter for the related constraints in the timetable view dialogs (reported by Xardeuss).
	- Improved the help for the constraints of type activities/teacher(s)/students (set)/room(s) occupy max sets of time slots from selection
	(we explain that the affected activities cannot be placed overlapping more than one set of selected time slots).
	- Minor source code improvements.
 7.9.3
	- Rare crash bug fixed, when using constraints of type activities/teacher(s)/students (set)/room(s) occupy max sets of time slots from
	selection, teacher(s)/students (set)/room(s) max activity tags per day/real day/week from set, or activities max activity tags from set
	in selected time slots, if the maximum allowed number of sets of time slots or tags from set was above 2 (reported by Yush Yuen).
 7.9.2
	- Added a new type of constraint, max days between each pair of consecutive activities (suggested by Yush Yuen).
	- Minor improvements.
 7.9.1
	- Bug fixes, when saving/restoring the settings to/from an ini file (discovered with the help of Andrea Primiani). The bugs appeared when
	saving the settings to an ini file, in which case the settings were not the current ones, but the ones from the previous FET session, and
	when restoring the settings from an ini file, in which case the user could have met useless warnings for some options, like checking for
	updates on startup or enabling the option 'group activities in the initial order'; also, in these situations, when restoring the settings
	from an ini file and meeting these warnings, the settings might have been retrieved/set incorrectly if the user clicked 'No' or 'Cancel'
	in the respective message boxes.
	- Corrected a compilation warning, for a variable set but not used (reported by Andrea Primiani).
	- Minor interface improvements.
	- Updated the Russian translation, by Alexey Chernous.
 7.9.0
	- Added a new type of constraint, activities max activity tags from set in selected time slots (suggested by Vinicius Rocha).
	- Added the option to enable/disable the use of span in the HTML timetables (suggested by Marinho Medeiros).
	- Minor improvements.
	- Updated the Italian translation, by Andrea Primiani.
 7.8.7
	- Critical interface bug fixes: When removing an activity tag in the constraints of type teachers/students max activity tags per day/real day
	from set or modifying/removing an activity tag in the constraints of type room(s) max activity tags per day/real day/week from set, the
	constraints were not correctly updated (reported by Yush Yuen).
	- Improved the English text - instead of 'he', 'his', and 'him' pronouns when referring to a teacher, we use 'he/she', 'his/her', and 'him/her'
	(suggested by Alexandre R. Soares and Andrea Primiani).
	- Improved the symbol for the 'not available' cells in the constraints of type 'not available' or 'preferred times' - it is now '✗' instead of 'X'.
	Also, the description of the deactivated activities and constraints now begins with '✗' instead of 'X'.
	- Added a Help button in the days and hours dialogs, for guidance; this is useful in modes other than the Official one (suggested by LEOBASSARTS).
	- Added the option to order the activities in the timetables by the tags, if a table cell contains more than one activity (suggested by
	Benahmed Abdelkrim; Volker Dirr suggested to consider only the printable tags).
	- Minor fixes.
	- Updated the Spanish translation, by Li Chong, who is the newly assigned translator. The Spanish translation is now nearly complete.
	- Added a new example file, by Benahmed Abdelkrim.
 7.8.6
	- Updated to Qt 6.11.1.
	- Rare crash bug fixes and other bug fixes (the program crashed in the constraints' dialogs if the filter was enabled and the user changed
	a constraint's comments and the new constraint was filtered out; also, in the activities/subactivities/group activities in the initial order
	dialogs, when changing an item's comments and the new item should have been filtered out, it was still shown until the user filtered the list
	again). Reported by mrtvillaret.
	- Improved the instructions for the constraints of type max terms between activities (suggested by mikkojoo).
	- Corrected the Arabic translation, by Benahmed Abdelkrim.
	- Added a new example file, by Benahmed Abdelkrim.
 7.8.5
	- When generating multiple timetables, there is now an additional report file which lists the timetables in ascending order of conflicts
	(suggested by Frank Rump).
 7.8.4
	- Corrected and improved the instructions for the new constraints of type room(s) max activities per teacher and building(s) min one
	activity in each available slot.
	- Corrected the Arabic translation, by Benahmed Abdelkrim.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
	- Updated the Italian translation, by Andrea Primiani.
 7.8.3
	- Converted the constraints of type building(s) min one activity in each non-break time slot to the similar constraints of type building(s)
	min one activity in each available time slot (suggested by Benahmed Abdelkrim). Also, these constraints must no longer be applied to all the
	buildings, but can be applied to any selection of buildings (again, suggested by Benahmed Abdelkrim).
	- Added some tests before the generation, if the timetable is impossible because of the constraints of type building(s) min one activity
	in each available time slot (suggested by Benahmed Abdelkrim).
	- Minor code improvements.
	- Corrected the Arabic translation, by Benahmed Abdelkrim.
 7.8.2
	- Updated to Qt 6.11.0.
	- Converted the recently introduced constraints of type room(s) max teachers repetitions to the constraints of type room(s) max activities
	per teacher (suggested by Andrea Primiani). The new constraint is clearer, and it is equivalent to the old one if we add 1 to the number
	of max repetitions per teacher to represent the number of max activities per teacher. Also, activities with several teachers are taken into
	consideration.
	- The export of statistics can now be configured to use long names and/or codes for the subjects, activity tags, teachers, and students
	(suggested by Cyrus Ireri).
	- Updated the Italian translation, by Andrea Primiani.
 7.8.1
	- Added two new constraint types, for exams in Algeria, Morocco, and maybe other countries: room(s) max teachers repetitions and building(s)
	min one activity in each non-break time slot. These constraints were suggested and tested by Benahmed Abdelkrim (previously in the FET-NSRT
	custom version) and have some preconditions (listed in their dialogs) to be used successfully.
	- Added the options to select whether to print the names and/or long names of the days/hours and names and/or long names and/or codes of
	the teachers in the teachers' free periods timetables and names and/or long names and/or codes of the teachers/students in the
	teachers'/students' statistics timetables (suggested by Cyrus Ireri).
	- Added the option to have long names on multiple lines for the days, real days, hours, real hours, subjects, activity tags, teachers,
	students sets, buildings, and rooms (suggested by Cyrus Ireri). In this way, you can split the long names on multiple lines in the
	resulted timetables.
	- It is now possible to have the institution name on multiple lines.
	- The option to print detailed teachers' free periods timetables was changed: if selected, the behavior is the same as in the older versions,
	but, if not selected, the program will print all the free teachers in each corresponding time slot, but without printing any additional
	information, and in the global order of the teachers (suggested by Cyrus Ireri, and maybe other users in the past).
	- Minor interface bug fixes and improvements (an aesthetic improvement was suggested by Rodica Lalescu, in the 'Space' shortcuts tab).
 7.8.0
	- Critical crash bugs fixed in the students groups/subgroups dialogs (following the report by miky).
 7.7.8
	- Critical crash bugs fixed in the students groups/subgroups dialogs, if the "Colors" check boxes were selected (reported by miky).
	- Removed the warnings that the constraints of type "activities max total number of students in selected time slots" can be very slow;
	hopefully, the constraints of this type work correctly.
	- Minor corrections and improvements.
 7.7.7
	- Added three new types of space constraints: room(s) pair of mutually exclusive time slots, room(s) pair of mutually exclusive sets of time slots,
	and room(s) occupy(ies) max sets of time slots from selection (suggested by Rodolfo Ribeiro Gomes). On this occasion, there were added the general
	constraints (for all rooms, not only for a single room, as in the previous versions) of type rooms max activity tags per day/real day/week.
	- Minor bug fixes and improvements.
 7.7.6
	- Corrected a few compilation warnings when using an older C++ compiler.
	- Updated the Italian translation, by Andrea Primiani.
	- Minor improvements.
 7.7.5
	- The command-line version now allows completely configuring the data to be printed in the HTML timetables, as in the GUI version
	(suggested by hold_find).
	- When choosing the data to print in the timetables, it was added a simple option to copy (propagate) all the settings from the
	current tab to all the tabs from 4 to 21 (suggested by GUEFFAZ REDA).
	- Updated the Arabic translation, by Benahmed Abdelkrim.
	- Minor improvements.
 7.7.4
	- Updated to Qt 6.10.2.
	- Bug fix: the human-readable text file should not have been shown if the user did not create or load a file (reported by GUEFFAZ REDA).
	- Improved the colors handling in the human-readable data (by g.theodoroy).
	- Minor improvements.
 7.7.3
	- Compilation bug fixed: it was impossible to compile FET with the option USE_SYSTEM_LOCALE enabled (reported by g.theodoroy).
 7.7.2
	- Improvements in the interface: the constraints with tables will be shown in human-readable form (suggested by GUEFFAZ REDA, and maybe other
	users in the past). g.theodoroy had useful suggestions and contributions, and wrote the code to divide the tables in the Mornings-Afternoons
	mode.
	- The detailed description of the teachers now include their 'not available times' constraints, in human-readable form (suggested by
	GUEFFAZ REDA).
	- Improvements in the interface: all the 'list constraints' dialogs now contain Up/Down buttons.
	- The user can view/save the file in a human-readable text form (it was DT's suggestion to allow saving the data as an HTML file).
	- The user can backup or restore the settings to/from an INI file (suggested in the past by Bobby Wise, and maybe by other users).
	- Minor interface bug fixes.
 7.7.1
	- Improved the CMake build files, by Michael Towers. Volker Dirr (assisted by Gemini and ChatGPT) also had some useful suggestions.
	- The FET translations now include also the Qt translations (suggested by Michael Towers).
	- Added more filters in the all time/space constraints dialogs: check boxes for miscellaneous, teachers, students, activities, subjects and tags,
	and rooms constraints (suggested by GUEFFAZ REDA, who also reported some critical bugs, fixed before the official release).
	Also, following a suggestion by GUEFFAZ REDA, the user selections for the check boxes are now saved/restored.
 7.7.0
	- The sources and the GNU/Linux binaries are now archived with tar.xz (suggested by Michael Towers).
	- It is now possible (and recommended) to build FET with CMake (minimum Qt version for CMake: 6.10) (suggested by Michael Towers, who also
	provided extensive instructions/help on how to do this; also Volker Dirr, assisted by ChatGPT and Gemini, suggested some important corrections).
	On this occasion, we added an improvement so that the engine is no longer compiled twice, but only once, as a static library (suggested by
	Volker Dirr, assisted by Gemini). QMake is still supported, but not recommended (one reason is that the engine is compiled twice, and another
	reason is that it is an old building method). Older Qt versions (5.15 to 6.9) are supported only with QMake. Chichi Lalescu suggested the code
	to make the conditional building of FET with the language preselected to the local language, enabling the option USE_SYSTEM_LOCALE.
	- Minor improvements (suggested by Michael Towers, found using Qt Creator).
 7.6.5
	- Improved the command line generation, by removing the additional thread which was checking for the possible existence of the 'sigwrite' file.
	The new check for the existence of this file is done in the already existing generation thread (idea and code suggested by Michael Chourdakis).
	- Minor improvement: the History states will now be stored in four std::deque-s instead of four std::list-s (but the improvement is not noticeable
	in practice).
	- Minor improvements.
 7.6.4
	- Modifying multiple constraints of type min (half) days between activities now applies only to the selected constraints, not to all the constraints
	(suggested by GUEFFAZ REDA).
	- Updated the Italian translation, by Andrea Primiani.
	- Code cleanup.
 7.6.3
	- Bug fix in the new feature, introduced in version 7.6.0, to view/edit the related constraints in the timetable view days vertical dialogs
	(reported by GUEFFAZ REDA).
	- Improved the layout of the option to view/edit the related constraints from the timetable view dialogs, to save space (suggested by GUEFFAZ REDA).
	- Corrected the Arabic translation, by Benahmed Abdelkrim (fixing an error reported by GUEFFAZ REDA).
 7.6.2
	- Minor bug fixes (reported by Volker Dirr, found using Cppcheck).
	- Minor bug fix when printing the advanced statistics.
	- Minor bug fix: the examples directory contained a special character, which gave warnings on some systems (reported by Andrea Primiani). On this
	occasion, some other example files were renamed, to avoid the special '+' character in a filename, which is not recommended on older systems.
	- Code improvements.
	- Updated the Italian translation, by Andrea Primiani.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 7.6.1
	- Bug fixes: when viewing the detailed description of an activity tag in the activity tags dialog, some types of related constraints were not listed.
	- Code improvements.
 7.6.0
	- Added the option to view/edit the time/space constraints associated with one or more teachers/students sets/rooms/activities, from the timetable
	view dialogs (suggested by Vangelis Karafillidis, and maybe by other users in the past).
 7.5.8
	- Updated to Qt 6.10.1.
 7.5.7
	- Crash bugs fixed, when using one or more constraints of type teacher(s)/students (set) max mornings/afternoons per week
	(in the Mornings/Afternoons mode) with the max allowed mornings/afternoons per week set to zero (reported by Thái Chí Phương).
	- Corrected a field in the Arabic translation, by Benahmed Abdelkrim.
 7.5.6
	- Code cleanup.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 7.5.5
	- Corrected an English field (reported by Vangelis Karafillidis).
	- Updated the Greek translation, by Vangelis Karafillidis.
 7.5.4
	- Changed the license of the program to the GNU Affero General Public License version 3 (Volker Dirr suggested to remove the term 'or later').
	- Logic bugs fixed in the generation algorithm.
	- Added a new type of constraint, activities max total number of students in selected time slots (suggested by Furkan Kızılaslan).
	Unfortunately, this constraint might have a bad behavior in practice; we need to scrutinize it before using it, and use it only if strictly
	necessary.
	- Implemented additional keyboard shortcuts: Ctrl+Shift+T/S/R for teachers/students/rooms days horizontal timetables. Also, the user can enable
	some other keyboard shortcuts from the Settings > Interface menu: + for adding, M for modifying, Delete for removing, A for activating, D for
	deactivating, C for comments, U for up, J for down, and W for weights (suggested recently by Alami Mohammed, and in the past by Pietro).
	- Minor improvements.
 7.5.3
	- Added a new and complete Turkish translation, by the newly assigned translator, Erdem Uygun (he was assisted by ChatGPT).
	- Updated the Vietnamese translation, which is now complete, by the newly assigned translator, Vũ Ngọc Thành (he was assisted by Gemini and ChatGPT).
 7.5.2
	- Updated to Qt 6.10.0.
	- The constraints of types room max activity tags per day/real day/week, teacher(s)/students (set) max activity tags per day/real day,
	and teacher(s)/students (set)/activities occupy max sets of time slots from selection will now accept any maximum limit, not just 1 or 2
	(suggested recently by moke, and suggested in the past by Thái Chí Phương and Vũ Ngọc Thành).
	- Code cleanup.
	- Updated the Italian translation, by Andrea Primiani.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 7.5.1
	- Updated to Qt 6.9.3.
	- Added a new type of constraint, activity(ies) begin(s) or end(s) teachers'/students' day (suggested recently by
	Nelson Gomes, and suggested in the past by ghani1990, Ali Doussary, YOUSSEF HOUIET, Željko Vrabec, and maybe other users).
	- Added a new type of constraint, activities occupy max sets of time slots from selection (suggested recently by k3nt0n, and
	maybe by other users in the past). The maximum value can be chosen by the user to be 1 or 2.
	- Memory and speed improvements for the constraints of type teacher(s)/students (set) max single gaps in selected time slots,
	teacher(s)/students (set) occupy max sets of time slots from selection, and teacher(s)/students (set) pair of mutually exclusive
	sets of time slots.
	- Changed the 'selected' symbol (now it is ✓) and the colors for the constraints with selected/not selected slots
	(suggested by k3nt0n, and by other users in the past). Rodica Lalescu suggested the new colors.
	- Other minor improvements.
 7.5.0
	- Added a new type of constraint, activities overlap completely or do not overlap (suggested by alege).
	- Minor interface improvements.
	- Corrected an Italian translation field, by Andrea Primiani (fixing an error reported by ggscuola).
 7.4.7
	- Minor interface improvements.
	- Added a keyboard shortcut, Ctrl+H, for the 'Timetable > Generate multiple' command (suggested by Alami Mohammed).
	- Corrected an Arabic translation field, by Benahmed Abdelkrim (fixing an error reported by Bachir Nacer Elhak Sayah).
 7.4.6
	- Updated to Qt 6.9.2.
	- Changed the (optional) colors in the dialogs for adding/modifying a constraint of type teacher(s)/students (set) occupy max sets of time
	slots from selection (constraint type which was introduced in the previous version), so that they are not similar to the (optional) colors
	in the dialogs for adding/modifying a constraint of type teacher/students set/room not available or (sub)activities preferred times, because
	the functionality is different (suggested by YOUSSEF HOUIET, who also suggested some of the colors; Rodica Lalescu also suggested some of
	the colors).
	- Added the option to reset all the spin boxes in the new constraint of type teacher(s)/students (set) occupy max sets of time slots from
	selection (constraint type which was introduced in the previous version) with a single click in the top-left corner of the table (suggested
	by GUEFFAZ REDA).
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
 7.4.5
	- Added a new type of constraint: teacher(s)/students (set) occupy max sets of time slots from selection (suggested recently by
	Sérgio Augusto Dias Castro; it was also suggested in the past by GUEFFAZ REDA and maybe other users; YOUSSEF HOUIET suggested
	the option to color the selected slots distinctively, and Andrea Primiani, the Italian translator, found some important English
	mistakes in the new constraint). The maximum value can be chosen by the user to be 1 or 2. This constraint might be useful for
	instance to constrain the teachers to work only maximum 2 shifts out of 3 per day.
 7.4.4
	- Added two new types of constraints: activities pair of mutually exclusive time slots and activities pair of mutually exclusive sets of
	time slots (suggested by Vũ Ngọc Thành).
	- The detailed description of the selected teacher in the teachers' dialog will show the total duration of his/her active activities
	(suggested by Bachir Nacer Elhak Sayah).
	- The program will keep the focus on the last pressed button in the dialogs which list the time/space constraints (suggested by more users,
	via YOUSSEF HOUIET).
	- A few English text fields were corrected/improved (reported by Volker Dirr, found using ChatGPT and Gemini).
	- A few Romanian translations were corrected/improved (reported by Volker Dirr, found using ChatGPT and Gemini).
 7.4.3
	- Added a new type of constraint: teacher(s)/students (set) pair of mutually exclusive sets of time slots (suggested by YOUSSEF HOUIET, and maybe
	other users in the past).
	- Code cleanup (fixing issues reported by Coverity Scan).
 7.4.2
	- Crash bugs fixed: if the user's file contained no activity tags, and if the user tried to add some time constraints for tags, such as teachers
	activity tag max hours daily, the program did not report the error and added the constraint with an empty tag, and later crashed with an assertion
	failed when editing that constraint or when trying to generate (reported by Bouazza El Idrissi, YOUSSEF HOUIET, and JoeLaw).
	- Code cleanup (suggested by Volker Dirr).
	- Updated the Bosnian translation, by Bolja škola.
 7.4.1
	- Bug fix: the activity tags' timetables of type time horizontal divided by days were always empty.
	- Other minor bug fixes in the interface.
	- Corrections/improvements in the generation of the HTML code for the timetables.
	- Updated the Italian translation, by Andrea Primiani.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
	- Updated the Bosnian translation, by Bolja škola.
 7.4.0
	- Added a complete Bosnian translation, by Bolja škola (assisted by Google Translate and ChatGPT).
	- Some punctuation marks are now translated, because in some languages, like Arabic, they are different from the Latin ones (reported/suggested
	by Walid).
 7.3.2
	- Interface bugs fixed in the teachers'/students' not available times time horizontal dialogs: when using a right-to-left writing system,
	the lines separating the days were drawn incorrectly (reported by GUEFFAZ REDA).
	- Interface improvements: the selected filters in the dialogs listing the constraints will be preselected in the corresponding combo boxes when
	adding new constraints (suggested by Massimo Mancini).
	- Interface improvements: changed the alternative text of the "Pause" push buttons from "Resume" to "Continue" in the timetable generate
	single/multiple dialogs (this change was done for clarity, especially when this text is translated into other languages; we need the meaning of
	this text to be clearly different from the meaning of the "Restart" push button, which is near it in the timetable generate multiple dialog, and
	which has a totally different functionality: stop the current generation and begin a new different one).
 7.3.1
	- Crash bug fixed, when importing activities from CSV files (reported by KR_OBS).
	- Added the option to pause the timetable generation (suggested by russell, GUEFFAZ REDA, Nahum Lipkunsky, and maybe other users in the past).
	This option is available in the single timetable generation dialog and for each thread in the multiple timetable generation dialog but,
	unfortunately, it will not allow the user to exit FET and resume the generation; you will need to keep the program and the computer running
	(but, of course, the paused generations will not consume processing power). GUEFFAZ REDA had some useful additional suggestions regarding
	this new feature: to show the [PAUSE] text with a bold text, and to disable the text edit widget showing the progress, if paused.
	- Bug fixes: some texts were shown aligned to the left when using a right-to-left writing system (reported by GUEFFAZ REDA).
 7.3.0
	- Added the possibility of restarting a certain thread in the generate multiple timetables dialog (suggested by Yush Yuen).
	- Added the possibility of viewing the initial order of placing the activities in the generate multiple timetables dialog (suggested by Yush Yuen).
	- Corrections in the interface: when resizing the constraints' dialogs the list of constraints remained too small (reported by Yush Yuen).
 7.2.6
	- Corrected some instructions/documentation referring to the advanced function of removing the redundant constraints (the inaccuracies were reported
	by Yush Yuen).
	- Added the option to highlight the incompletely assigned teachers in the teachers' statistics, by comparing their target number of hours with their
	assigned list of activities (suggested by GUEFFAZ REDA).
	- Updated the Italian translation, by Andrea Primiani.
 7.2.5
	- Updated to Qt 6.9.1.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 7.2.4
	- Added a new type of constraint for the Terms mode: teacher(s) max hours per term (suggested by mikkojoo).
 7.2.3
	- Timetable generation code improvements in the new constraints of type teacher(s)/students (set) max single gaps in selected time slots (found with
	the help of Yush Yuen).
	- Bug fix: the option '--printteachers=[true|false]' of FET-CL was not correctly recognized, because of a typo in the source code (reported by samloba).
	- The inactive items (activities, subactivities, time constraints, space constraints, and group activities in the initial order items) will have a
	corresponding distinctive color (suggested by GUEFFAZ REDA).
 7.2.2
	- Bug fix: for partial timetables, the conflicts for the constraints of type teacher(s)/students (set) max single gaps in selected time slots were
	not logged.
 7.2.1
	- Added the constraints of type teacher(s)/students (set) max single gaps in selected time slots (suggested and tested by Yush Yuen).
	- The description of the constraints involving activities will now show an 'X' before the id if the activity is deactivated (suggested by GUEFFAZ REDA).
	- Minor interface bug fix: when restoring the default settings, the option 'The font is user selectable' was not updated correctly
	(reported by Vangelis Karafillidis).
 7.2.0
	- Minor interface bug fix (the bug was found by watching an online FET tutorial presented by Apisit Piamnoi).
 7.1.9
	- Minor bug fix: the hours' names and long names were not correctly separated by a new line character in the timetables if the user selected this
	option (reported by Željko Vrabec).
 7.1.8
	- Potential bug fix: the default translated names of some days of the week could have been the same, leading to critical bugs. Now we use generic default
	names for the days in any language: D1, ..., D5 (and H1, ..., H12 for the hours). Of course these can be changed by the user after the initial setup.
	- Potential bug fix: if the names 'year_name Automatic Group' or 'group_name Automatic Subgroup' are colliding, employ some anti-collision tricks.
 7.1.7
	- Bug fix in the command line version: if the user wrote the command to suppress the activity tags timetables, the program suppressed instead
	the activities timetables (reported by Nahum Lipkunsky).
	- The order of the entries in the ChangeLog file is now reversed (improvement made by Nahum Lipkunsky).
 7.1.6
	- Added a file communication protocol for the FET-CL executable, as suggested by Nahum Lipkunsky: if the user creates a file named exactly 'sigwrite',
	the program will output the current and highest stage timetables, without interrupting the generation, and remove this file from the disk.
	This facility was suggested also by other users in the past.
	- Improved the fet.desktop file by adding the possibility of opening a specified fet file on startup.
	- Added a mime file for GNU/Linux, so that it is possible to open directly a fet file with FET from the file browser; also in the file browser the fet
	files will have attached the FET icon (suggested by Željko Vrabec, who also wrote the fet.xml mime file). These features should be present on GNU/Linux,
	after doing a "make install", but you might need to execute some additional commands post-installation, as explained in the README file.
 7.1.5
	- Improved the preliminary feasibility test of the constraints of type teacher(s)/students (set) activity tag min hours daily.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
	- Updated the French translation, by Pascal Cohen.
	- Updated the Greek translation, by Vangelis Karafillidis.
 7.1.4
	- Crash bugs fixed, in the dialog for modifying a constraint of type max activity tags from a set per day/real day/week for a room, when removing
	an activity tag (reported by Nguyễn Hữu Tuyên).
	- Improved the constraints of type teacher(s)/students (set) activity tag min hours daily - now they allow the user to specify the minimum required
	number of days per week with the selected tag (suggested by Nahum Lipkunsky).
	- Improved the data file structure.
	- Improved the resulted time horizontal timetables (suggested by Vangelis Karafillidis).
	- Updated the Greek translation, by Vangelis Karafillidis.
	- Updated the Italian translation, by Andrea Primiani.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 7.1.3
	- Added a new constraint in the Block planning mode, two sets of activities have the same sections (suggested by Edward Downes and Richard B. Gross).
	- Added the possibility of modifying multiple selected constraints at once, with a single click, for these types of time constraints: teacher min/max
	real days/mornings/afternoons per week, teacher min/max hours per real day, teacher min hours per morning/afternoon, teacher max hours per all afternoons,
	teacher mornings/afternoons early max beginnings at second hour, teacher max gaps per real day/per week for real days/per morning and afternoon
	(in the Mornings-Afternoon mode).
	- Updated the Greek translation, by Vangelis Karafillidis.
	- Updated the French translation, by Pascal Cohen.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
 7.1.2
	- Updated to Qt 6.9.0.
	- Added advanced filters in the dialogs which list the time/space constraints (suggested by Vangelis Karafillidis).
	- Added the possibility of modifying multiple selected constraints at once, with a single click, for these types of time constraints: teacher min/max
	days per week, teacher min/max hours daily, teacher max hours continuously, and teacher max gaps per day/week (suggested by Vangelis Karafillidis).
	- Added the possibility of being informed by a beep and/or a notification command after each successful timetable in a multiple generation
	(suggested by Benahmed Abdelkrim).
 7.1.1
	- Updated to Qt 6.8.3.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
	- Updated the Italian translation, by Andrea Primiani.
 7.1.0
	- Added the constraints of type teacher(s)/students (set) pair of mutually exclusive time slots (suggested by NYC FET, igorsch, and maybe other users
	in the past).
 7.0.8
	- Minor corrections in the resulted HTML timetables.
 7.0.7
	- Improved the fet XML file formatting (only the spacing was changed - the text should remain the same). This was suggested by ismailbsrn's file formatting.
 7.0.6
	- Bug fix in the constraints teachers not available time horizontal: the hidden rows might have been incorrectly modified (reported by GUEFFAZ REDA).
	This bug was introduced in the previous version.
	- The list/add/modify group activities in initial order items dialogs will have a 'Show related' check box for the students filter.
 7.0.5
	- Improved the add/modify constraints dialogs which include a times table: the user can click on the top-left corner instead of the button "Toggle all",
	button which will now toggle/swap empty (green) cells with X (red) cells. Suggested by Volker Dirr and Michael Towers; Michael Towers also suggested the
	main idea for coding this. Volker suggested to use the ∀ symbol in the top-left corner to express this functionality.
	- The add/modify constraints dialogs with tables will each have a separate option, a check box, for choosing whether to use colors or not (suggested
	by GUEFFAZ REDA).
	- Added filters in the constraints teachers/students not available time horizontal views (suggested by GUEFFAZ REDA).
	- The students filters in the dialogs for listing the constraints and in the dialogs for adding/modifying the constraints will have a 'Show related'
	check box (suggested by more users in the past).
 7.0.4
	- Implemented additional table cells/lines to better separate the different days in the time horizontal/vertical timetables (suggested by Pietro, Matsumoto,
	liquid, Mario, geokom, and maybe other users in the past).
	- When modifying the constraints which include times tables, the slots marked with X will be bold (it was an inconsistent behavior, compared to adding such
	constraints, and it was reported by infoo_).
	- Added a swap button in the constraints which include times tables, to swap the empty (green) cells with the cells marked with X (red). Suggested by infoo_.
 7.0.3
	- Minor improvements.
	- Corrected and improved the German translation, by Volker Dirr (following a bug report by uni_instructor).
 7.0.2
	- Minor improvements.
 7.0.1
	- Updated to Qt 6.8.2.
	- Improved the reporting of warnings/errors in the command-line version (suggested by Nahum Lipkunsky). The potential warnings/errors issued before the
	generation will be written in their respective file, instead of being written on the console. The special UTF-8 characters will be correct in this case.
 7.0.0
	- Improved the algorithm: the constraints of type min days between activities with the weight < 100% were previously treated a little differently than the
	other constraints with the weight < 100% (the min days between activities constraints were privileged: the algorithm tried a bit harder to respect them).
	Now, all the constraints with the weight < 100% will be treated similarly. This implies that the files containing constraints of type min days between activities
	with the weight < 100% will be solved possibly faster, but with possibly more broken constraints of this type. So, you might need to increase the weights of the
	constraints of type min days between activities with the weight < 100%.
	- Updated the Russian translation, by Alexey Chernous.
 6.28.7
	- Minor interface improvements.
	- Source code typos corrected (found with the help of Nahum Lipkunsky).
 6.28.6
	- Added the option to sort alphabetically the constraints in their specialized dialogs (suggested by Vangelis Karafillidis).
	- Improved the timetable view dialogs, as suggested by GUEFFAZ REDA: you can choose whether to merge the table cells which correspond to the same activity
	(by default selected) and whether to use colors (by default not selected), and the timetable views by days horizontal/vertical will show the number and
	the duration of the displayed activities.
 6.28.5
	- Improved the divide year by categories dialog, as suggested by Vangelis Karafillidis: added the option to copy the categories and divisions from another
	students year, and added the option to make the first category permanent. On this occasion there was corrected a possible crash bug in this dialog.
 6.28.4
	- Crash bugs fixed, if trying to add constraints teacher/teachers max hours daily in an hourly interval with max hours daily = 0. Reported by math.
	- The timetable views days horizontal/vertical now contain check boxes to show/hide the teachers, the students, the subjects, the activity tags,
	and the rooms (suggested by GUEFFAZ REDA).
 6.28.3
	- Updated to Qt 6.8.1.
 6.28.2
	- Bug fix when modifying a constraint of type max half days between activities (hopefully not met in practice).
	- Bug fix for the constraint activity preferred room: the 'permanently locked' check box was always initialized as selected when editing this kind
	of constraint.
	- The constraints with times tables will show the real days and the real hours in the Mornings-Afternoons mode (suggested by more users in the past).
	- The user can choose to overwrite the files of the previous single generation (suggested by Thai Chi Phuong, Benahmed Abdelkrim, pnlshd, bharatstank,
	and maybe other users).
	- Code improvements.
 6.28.1
	- Interface bug fixed: the combo boxes could be too large in the constraints' dialogs (reported by uni_instructor).
	- Improved the dialogs for adding/modifying the constraints of type two activities ordered, two activities ordered if same day, two activities
	consecutive, two activities grouped, and three activities grouped (suggested by uni_instructor).
	- Improved the instructions/help for some constraints (suggested by uni_instructor).
 6.28.0
	- Converted the interface files for the time and space constraints. There are much less source files now. This implies more things:
	shorter compilation time, smaller package sizes, less fields to translate and smaller translation files, nicer looking constraints' dialogs.
	Also, the dialogs listing the constraints of a certain type allow multiple selection, and have buttons for activating/deactivating the constraints,
	change the constraints' weights in bulk, and set the comments for a constraint. Qt Creator and Valgrind were invaluable tools for this work.
	- Improved the activity planning dialog when swapping the teachers, if one cell was empty (suggested by uni_instructor).
 6.27.0
	- It is now possible to change the interface style and color scheme (but only when using Qt version 6.8.0 or later).
	- Added the option to add/remove an activity tag to a selection of (sub)activities with a single click (suggested by Benahmed Abdelkrim and pnlshd).
	- Added a note to the constraints referring to an interval, that the start hour is included and the end hour is not included (suggested by Pier,
	and other users in the past).
	- Minor improvements.
 6.26.2
	- Corrected some rare cases of old timetable files possibly being overwritten when generating single timetables.
	- Minor improvements.
 6.26.1
	- In the command-line version, the newly generated timetables will be put in a new directory each time. The old timetables won't be overwritten.
 6.26.0
	- Updated to Qt 6.8.0.
	- The newly generated timetables will be put in a new directory each time. In the single generation, the old timetables will not be overwritten and
	in the multiple generation the user will not be forced to remove the old timetables before generating. Suggested by pnlshd, and other users in the past.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 6.25.3
	- Updated to Qt 6.7.3.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
 6.25.2
	- Added the constraint room max activity tags from a set per week (suggested by YOUSSEF HOUIET). This constraint accepts as the maximum number of
	tags 1 or 2, and must be assigned to a real (not virtual) room, room which also does not appear in any set of real rooms of any virtual room.
	- Enabled the use of constraints teacher(s)/students (set) activity tag max hours daily in the Mornings-Afternoons mode (suggested by hoangnv231).
	- Added the option to print the legend starting with and ordered by the codes in the timetables (suggested by M.zais).
	- Improved the Italian translation, by Andrea Primiani.
 6.25.1
	- Added the constraints room max activity tags from a set per day/real day (suggested by Thai Chi Phuong). This constraint accepts as the maximum
	number of tags 1 or 2, and must be assigned to a real (not virtual) room, room which also does not appear in any set of real rooms of any virtual room.
	- Minor improvements.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
 6.25.0
	- Added the constraints teacher(s)/students (set) max activity tags from a set per day/real day (suggested by Thai Chi Phuong and Vũ Ngọc Thành).
	This constraint accepts as the maximum number of tags 1 or 2, and incorporates the old-style constraints teacher(s)/students (set) max two
	activity tags per day/real day from N1, N2, N3.
	- Added the constraints teacher(s) no two consecutive days (suggested by Khelifi Fouad Mohssen).
 6.24.1
	- Added the option to change with a single click the weights of a whole selection of time/space constraints (in the all time/space constraints dialogs)
	(suggested by Bahri Abderezak on Facebook, and maybe other users in the past).
	- After generating a new timetable, if some timetable view days horizontal/vertical dialogs were already opened, they will remember their selected
	teacher/students set/room (suggested by Kamel Ben on Facebook). Also, in all the timetable view dialogs, the current cell will be remembered
	(but not the whole selection of cells, if there are more cells selected).
 6.24.0
	- Unlocked the imperfect constraints and the advanced features and removed their usage warnings (suggested by more users in the past).
	They are working very well in practice and the menu locks and warnings are not needed. The exception is the advanced 'Group activities
	in the initial order of generation' option.
	- Removed the warnings referring to the constraints of type activities occupy min/max time slots from selection and activities min/max simultaneous
	in selected time slots (suggested by potrempe, fourat, and YOUSSEF HOUIET). The constraints are highly optimized and work very well in practice.
	- The comments in the timetables will no longer have an italic font (suggested by Cyrus Ireri).
	- Other minor interface improvements.
 6.23.0
	- Very rare but critical crash bugs fixed, in the Mornings-Afternoons mode (reported by Anonymous participant on a Facebook group about scheduling).
	- Very rare crash bugs fixed (if when printing the teachers'/students' statistics the radio button 'Days vertical' was selected, the program crashed).
	- Minor bug fixes and improvements in the output of the timetables.
	- The printing of the timetables from the interface now works also when using a right-to-left writing system (suggested by Benahmed Abdelkrim,
	Mohamed Ait Ichou, and maybe other users in the past). The exception is when printing the statistics. Redha Rahmane reported on a Facebook group
	about scheduling an important bug found in the first test version, which was fixed in the final version.
	- Printing the timetables from the interface will now center the tables (only horizontally). Suggested by Muhammad Ratrout on Facebook, and by
	Benahmed Abdelkrim.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
 6.22.3
	- Added the option to print the legend (summary of names, long names, codes, and comments) of the used subjects, activity tags, teachers, students,
	and rooms in the timetables (suggested by mskalsi and maybe other users in the past). The feature is disabled by default and can be enabled from
	the 'Settings -> Timetables -> Data to print in timetables' menu.
	- Minor corrections and improvements in the output of the timetables (mskalsi suggested a larger font for the institution name. While we did not implement
	exactly this, we set a bold font for the institution name. Also, this is done through the CSS file, so the user can change this behavior if needed).
	- Improved the Italian translation, by Andrea Primiani.
 6.22.2
	- Corrected the main form appearance under older Qt versions.
	- Minor improvement: added an explanation about how the constraints of type students (set)/teacher(s) max room/building changes per week work
	(suggested by Vũ Ngọc Thành and Volker Dirr).
	- Updated the Italian translation, by Andrea Primiani. It is now complete.
	- Improved the Brazilian Portuguese translation, by Alexandre R. Soares.
	- Corrected the Romanian translation, by Liviu Lalescu (the typos/small errors were found using Ispell / Aspell).
 6.22.1
	- Updated to Qt 6.7.2.
	- Corrected and improved the output of the HTML timetables (reported/suggested by Cyrus Ireri).
	- Added the teachers/students/rooms days vertical options when viewing the timetable from the interface (suggested by Mohamed Ait Ichou,
	YOUSSEF HOUIET, and maybe other users in the past).
	- Corrected the timetable view dialogs when using a right-to-left writing system (previously, the separation lines were drawn incorrectly).
	Reported by Benahmed Abdelkrim.
	- Minor improvement: removed the brackets in the menu entries for viewing the timetables (suggested by Volker Dirr).
	- Updated the Italian translation, by Andrea Primiani.
 6.22.0
	- Added long names for the days, real days (in the Mornings-Afternoons mode), hours, and real hours (in the Mornings-Afternoons mode), and
	long names and codes for the subjects, activity tags, teachers, students, buildings, and rooms. Also, it is now possible to choose from the Settings menu
	which of this information to print in the timetables (suggested by Jude G, Cyrus Ireri, and other users). Cyrus Ireri helped with testing and reports,
	and Benahmed Abdelkrim found and reported a critical bug for the Mornings-Afternoons mode (which was fixed in the final version).
	- Minor bug fix in the import from CSV files (reported by Darren McDonald).
 6.21.1
	- Critical bug fix in the Mornings-Afternoons mode, when saving the locked fet file (the real days per week and the real hours per day were not saved).
 6.21.0
	- In the Mornings-Afternoons mode the timetables will show/use the real days/hours (suggested by Mohamed Ait Ichou, danghoan, Hieu Nguyen Trong, and
	maybe other users). TongThanhKieu suggested thicker lines between the morning and the afternoon in the timetable view teachers/students/rooms
	days horizontal dialogs.
	- Very rare crash bugs fixed when reading a corrupted input file (reported by vlaicumihnea).
 6.20.0
	- Updated to Qt 6.7.1.
	- Added two new types of constraints: teacher(s)/students (set) min gaps between activity tag/ordered pair of activity tags between morning and
	afternoon, in the Mornings-Afternoons mode (suggested by victorcapel).
	- Minor bug fixes: when using the activity planning dialog and activating/deactivating activities/subactivities using the activate/deactivate buttons
	(as opposed to selecting/deselecting the 'active' check box from the modify activity/subactivity dialogs, which worked correctly), the activity planning
	dialog was not updated immediately (reported by Cyrus Ireri).
 6.19.5
	- Corrected the two Windows batch files which start the program in the Fusion and Windows styles, to take care of possible space characters in the
	path to the FET executable (bug reported by Khafallah Oualid).
	- Minor corrections.
 6.19.4
	- Minor corrections.
 6.19.3
	- Minor improvement to the highlighting of the selected row(s)/column(s) in the time horizontal view of the teachers'/students' not available times.
 	- Code cleanup.
 6.19.2
	- Bug fix: when opening a file on program startup with the command "fet filename.fet", the recent files list was not updated correctly with the file's
	complete path, if it was not specified (this bug was introduced in the previous version).
 6.19.1
	- Updated to Qt 6.7.0.
	- You can now open a file directly when starting the FET interface: "fet filename.fet" (recently suggested by Cyrus Ireri, and also suggested in
	the past by MING-KIAN JONATHAN CEDRIC LEE KIM GNOK, Volker Dirr, and maybe other users).
	- Better highlighting of the selected row(s)/column(s) in the tables (suggested by Cyrus Ireri, who also contributed with a bug report on the new code).
	- Minor bug fixes, by Volker Dirr, when printing the timetables / advanced statistics from the interface.
	- Code cleanup.
 6.19.0
	- Updated to Qt 6.6.3.
	- Added two new types of constraints: teacher(s)/students (set) min gaps between activity tag/ordered pair of activity tags per real day, in the
	Mornings-Afternoons mode (suggested by victorcapel). On this occasion some bugs in the routine used to check the final timetable were corrected
	(they did not affect the generation). Benahmed Abdelkrim contributed with a bug report on the new code.
	- Minor bug fix: if the user changes the mode to Mornings-Afternoons, the constraints of type min/max days between activities will be adjusted if
	necessary (if the number of min/max days between activities is greater than the new number of real days per week).
	- Minor bug fix in the description of the recorded history state when adding multiple constraints of type activities same starting hour / occupy
	max different rooms. Also, now the order of the added constraints is given by the id of the first activity from each constraint.
	- Minor bug fix: when reading a wrong file containing an activity without a specified subject, FET will report an error on reading the file
	instead of possible assertions failed when trying to edit the data or generate the timetable (reported by vlaicumihnea).
	- Added a "Black" check box option in the statistics print from the interface, so that the fonts won't be gray, but black (suggested by Cyrus Ireri).
	On this occasion, a minor correction was done in the exporting of the advanced statistics to the disk (if the HTML level was 7 - colors, the fonts
	of line 2 should have been black, not gray).
	- Minor change: The section "Timetable_Generation_Options_List" (which may contain elements of type "GroupActivitiesInInitialOrder") will be printed
	even if it is empty.
	- Added four new example files, by Alexey Chernous.
	- Added three new example files, by activityum.
	- Updated the Russian translation, by Alexey Chernous.
 6.18.1
	- Minor bug fixes in some English fields.
	- Minor bug fixes / improvements when reading an invalid file (reported by Cyrus Ireri).
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares. It is again complete.
	- Updated the Greek translation, by Vangelis Karafillidis. It is again complete.
 6.18.0
	- Minor bug fixes: if there were no teachers in the file and the user added multiple constraints, one for each teacher, there were recorded
	useless history points.
	- Added a new type of constraint: teacher(s) / students (set) max room changes per (real) day in an hourly interval (suggested by giardiniere and
	other users in the past).
 6.17.0
	- Updated to Qt 6.6.2.
	- Crash bug fixed when spreading the activities evenly over the week (this bug was introduced in FET version 6.12.0, released on 13 November 2023).
	Reported by GUEFFAZ REDA.
	- Minor improvement: if the spreading of the activities evenly over the week does not affect the data, there will not be registered a new history state.
	- Other minor bug fixes and improvements.
	- Added a new type of constraint: teacher(s) / students (set) max building changes per (real) day in hourly interval (suggested by Vũ Ngọc Thành
	and other users in the past). Unfortunately, for some files using constraints referring to the building changes the timetable generation speed might
	decrease with about 2% - 4%. For a file with many constraints referring to building changes we even noticed a 12% speed of the generation decrease,
	but this is hopefully very rare.
	- Added a new type of constraint: teacher(s) / students (set) max hours daily in an hourly interval (suggested by Cyrus Ireri, and in the past by many
	other users). This constraint type can be used, apart from its primary purpose, to set a dynamic break for the teachers / students.
 6.16.1
	- The constraints of type activity(ies) begin(s)/end(s) student(s)'/teacher(s)' day are now allowed to have weight <100% (suggested by maxi_mus).
	- Minor improvements in some English fields.
	- Minor code improvements.
 6.16.0
	- Many source code updates and improvements (using ideas from Volker Dirr).
	- Minor bug fix in the interface (reported by Volker Dirr).
	- Minor improvement when saving the history data file (using ideas from Volker Dirr).
	- Updated the Bulgarian translation, by Hristiyan Dimitrov, who is the new translator.
 6.15.1
	- Correction for saving/retrieving the history on/from the disk: if the data structure changes, the history will be invalidated, instead of
	possible bugs/crashes of the program (using an idea of Volker Dirr).
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares. It is again complete.
 6.15.0
	- Added the possibility of saving the history to the hard disk, next to the saved .fet data file (suggested by uni_instructor and ngoctp29121982).
	This option is by default disabled and can be enabled from the settings.
	- Minor improvements in the memory consumption (the details of the history operations are now stored archived).
	- Code cleanup.
 6.14.2
	- The 'printable' option of the activity tags will be considered when exporting the generated timetable as a CSV file (so that the nonprintable
	activity tags will not appear). Suggested by pnlshd.
	- Code cleanup.
 6.14.1
	- Critical crash bugs fixed, when removing space constraints from their dialogs (not from the 'all space constraints' dialog)
	(reported by gerry). These bugs were present since FET version 6.12.0, released on 13 November 2023.
 6.14.0
	- Implemented the HTML exporting and the printing of the timetables for the buildings (suggested by Benahmed Abdelkrim).
	- Minor corrections in the HTML exporting and in the printing of the timetables.
	- Code cleanup.
 6.13.2
	- Updated to Qt 6.6.1.
	- Bug fix: when generating multiple from the GUI or generating from the command-line with a time limit, for some impossible timetables
	the generation could go on indefinitely without respecting the specified time limit. The bug was introduced in version 6.7.3, which was released
	on 24 November 2022.
	- Added an additional test for the feasibility of the generation in the Mornings-Afternoons mode (suggested by sunnysolanki76).
	- Code cleanup.
 6.13.1
	- Crash bugs fixed, when working with the new 'History' feature and locking/unlocking activities from the 'Timetable view' dialogs
	(reported by Vangelis Karafillidis). These bugs appeared in version 6.12.0, with the introduction of the 'History' feature.
	- Minor interface bug fixes (reported by Volker Dirr).
	- Code cleanup.
 6.13.0
	- Added a kind of data file autosave feature (suggested by mohammed, Vangelis Karafillidis, DT, and maybe other users). This feature is optional,
	and by default it is disabled (it can be enabled from the 'File > Autosave settings' menu entry).
	- If the description of the operation to be logged in history is too large, it will be truncated to maximum 20,000 characters, so that the history
	won't occupy too much memory.
	- When printing the timetables from the interface, without colors, the user can select the option that all the fonts will have the black color,
	instead of gray and silver being used for some categories of text (suggested by Nikandros and Volker Dirr).
	- Updated the Arabic translation, by Benahmed Abdelkrim. It is again complete.
 6.12.0
	- Added an undo/redo system (actually, the possibility of saving and restoring data states to/from history). Suggested by: Massimo Mancini, uni_instructor,
	Anthony Siaudeau, Zsolt Udvari, pekuon, and maybe other users. DT had some useful suggestions regarding this new feature.
	- The confirmation for activating/deactivating activities/time constraints/space constraints can now be disabled (suggested by pnlshd).
	- The dialogs for activities/all time constraints/all space constraints now contain a count of the selected items (suggested by pnlshd).
	- Minor improvements.
	- Updated the Russian translation, by Alexey Chernous.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares. It is again complete.
 6.11.1
	- Minor improvements in the time horizontal view dialogs of the teachers / students not available times, which were introduced in the previous FET version.
	Suggested by Liviu Lalescu and Vangelis Karafillidis.
	- Improvements in the dialogs of not available times for teachers / students and teachers / students / rooms timetable view time horizontal,
	the lines separating the days are thicker.
	- Other minor improvements.
 6.11.0
	- In the dialogs of all activities, all time constraints, and all space constraints, the list of activities / time constraints / space constraints
	is multi-selectable (suggested by T. Renganathan, Yush Yuen, daviodan, Lizio, fartoto_dz2004, Vangelis Karafillidis, and maybe other users).
	- Added an option in the dialogs add time / space constraints for the teacher(s), so that you can now add individual constraints for each teacher
	with a single click (suggested by Valdo, Julio González Gil, utismetis, Davide Cottignoli, mercurialuser, auriolar, Rodolfo Ribeiro Gomes, pg788, satellite2,
	Zafar Allah Askar, nouvakis, mbarsan, pgsrihr, Massimo Mancini, Chafik Graiguer, Vangelis Karafillidis, Fritzlang, wojgp, and maybe other users).
	- Implemented a time horizontal view of teachers / students not available times constraints (suggested by Vangelis Karafillidis). These views
	are accessible from the teachers / students time constraints menus.
	- The cells in the three timetable view time horizontal dialogs can now be made very small, so that you can have a better view of the overall timetable.
	- Minor bug fixes / improvements in the export of the timetables if using HTML level 6.
	- Minor improvements.
 6.10.0
	- Important bug fixes and improvements concerning the advanced function of removing the redundant constraints. Some of the bugs were present since
	the introduction of this function, in FET version 5.7.1, released on 6 October 2008, and others were present since the introduction of the facility
	to activate/deactivate constraints, in FET version 5.16.0, released on 12 December 2011.
	- Added the option to show/hide the subjects, teachers, students, and rooms, in the Print dialog and in the HTML timetables, in addition to
	the already existing facility of this type for the activity tags. Suggested by Silver, Drago, xtzetzias, and maybe other users.
	- Updated the German translation, by Volker Dirr.
 6.9.7
	- Updated to Qt 6.6.0. This involved updating the FET code in many places (using an easy search-and-replace), to eliminate the new compilation
	warnings (referring to the use of the deprecated function qAsConst). Now you will need a C++17 complying C++ compiler to compile FET.
	- Minor improvement in an English field.
 6.9.6
	- Updated to Qt 6.5.3.
	- Very rare crash bugs fixed (reported by Rouge Rosé).
	- Code cleanup.
 6.9.5
	- Corrected a few English fields, by Vangelis Karafillidis.
	- Updated the Greek translation, by Vangelis Karafillidis. It is now complete.
 6.9.4
	- Added a new type of constraint, max hourly span of a set of activities (suggested by pnlshd).
	- Minor code improvements.
	- Corrected a few English fields, by Vangelis Karafillidis.
	- Updated the Greek translation, by Vangelis Karafillidis.
 6.9.3
	- Updated to Qt 6.5.2.
	- The activities import/export from/to CSV files will now process correctly the individually modified teachers, subjects, activity tags,
	and students of the subactivities. The different components will be separated by the | symbol. Suggested by ngoctp29121982 and Volker Dirr.
	- Corrected a few English fields, by Vangelis Karafillidis.
	- Updated the Greek translation, by Vangelis Karafillidis.
 6.9.2
	- Minor improvements in the add/modify constraint min half days between activities dialogs, when using the Mornings-Afternoons mode
	(suggested by Vũ Ngọc Thành).
	- Updated the Russian translation, by Alexey Chernous.
 6.9.1
	- Updated to Qt 6.5.1.
	- Corrected a few English fields, by Vangelis Karafillidis.
	- Updated the Italian translation, by Andrea Primiani.
	- Updated the Greek translation, by Vangelis Karafillidis.
 6.9.0
	- Updated to Qt 6.5.0.
	- Added two batch files for Windows, making it possible to start the FET interface in the Fusion or Windows styles (suggested by Volker Dirr).
	Unlike the standard Qt style, these styles respect the dark mode on the Windows operating system, if the user selected it (starting with
	Qt version 6.5.0).
	- Improvement: if there are present 'group activities in the initial order' items in the data file, but all of them are inactive,
	there will not be issued a warning regarding this advanced feature at the start of the generation of the timetable.
	- Improved the dialog of 'group activities in the initial order' items.
	- Code cleanup (suggested by Volker Dirr, found using the function 'Analyze > Clang-Tidy and Clazy' of Qt Creator).
	- Updated the Italian translation, by Andrea Primiani.
	- Updated the Greek translation, by Vangelis Karafillidis.
 6.8.7
	- Updated to Qt 6.4.3.
	- Improved the method of selection of the interface font (suggested by giardiniere).
	- Updated the Italian translation, by Andrea Primiani, who is the new translator.
 6.8.6
	- Code cleanup.
	- Minor corrections in the English text.
 6.8.5
	- Code cleanup.
	- Minor corrections in the English text, by Darren McDonald and Liviu Lalescu.
 6.8.4
	- Code cleanup.
	- Minor corrections in the English text. The typos were found using a program written by Volker Dirr.
	- Updated the Greek translation, by Vangelis Karafillidis.
	- Minor corrections in the Romanian translation, by Liviu Lalescu. The typos were found using a program written by Volker Dirr.
	- Updated the German translation, by Volker Dirr.
 6.8.3
	- Code cleanup.
	- Updated some strings in the English text.
	- Updated the Italian translation, by Francesco Rizzo.
	- Updated the German translation, by Volker Dirr.
	- Updated the Romanian translation, by Liviu Lalescu.
	- Updated the French translation, by Pascal Cohen.
	- Updated the Greek translation, by Vangelis Karafillidis.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares. It is now complete.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 6.8.2
	- Speed improvements when using the advanced filter for the (sub)activities in the case of very large data.
	- Minor improvements.
	- Minor corrections in the Romanian translation, by Liviu Lalescu. The typos were found using a program written by Volker Dirr.
	- Updated the Greek translation, by Vangelis Karafillidis.
	- Updated the German translation, by Volker Dirr.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares. It is now almost complete.
 6.8.1
	- Added the possibility to lock/unlock the activities selected with an advanced filter (suggested by giardiniere).
	- Interface bug fixes.
	- Code cleanup.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
 6.8.0
	- Added an advanced filter in the activities/subactivities dialog (similar to the existing advanced filter in the all time/space constraints dialog).
	Also, it is now simpler to activate/deactivate the (sub)activities in these dialogs - there were added activate/deactivate buttons, such that it is no longer
	needed to enter the "Modify (sub)activity dialog". Also, it is now possible to activate/deactivate with a single button all the listed (filtered) (sub)activities.
	Also, in the all time/space constraints dialog, it is now possible to activate/deactivate with a single button all the listed (filtered) time/space constraints.
	Suggested by Horațiu Hălmăjan, Yush Yuen, Constantin Romulus, Nguyễn Hữu Duyệt, noddy11, Anthony Siaudeau, Vangelis Karafillidis, and Liviu Lalescu.
	- Various improvements and minor bug fixes.
	- Updated the Romanian translation, by Liviu Lalescu.
	- Updated the Greek translation, by Vangelis Karafillidis.
	- Updated the French translation, by Pascal Cohen.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
	- Updated the German translation, by Volker Dirr.
 6.7.8
	- Updated to Qt 6.4.2.
	- Code cleanup.
 6.7.7
	- Interface improvement: in the activities dialog, in the list of time constraints directly related to the selected activity, there will be shown the related
	constraints of type teacher/students set not available times.
	- Minor improvements.
	- Code cleanup.
 6.7.6
	- Interface bug fix: in the activities dialog, in the list of space constraints directly related to the selected activity, the constraints of type teacher/students
	set home room(s) which affected this activity were not shown. Reported by giardiniere and Volker Dirr.
 6.7.5
	- Minor corrections.
	- Code cleanup.
 6.7.4
	- Added the possibility to select, in the Mornings-Afternoons mode, instead of min days between activities, the number of min _half_ days between activities,
	when adding activities from the interface or when importing them from CSV files (suggested by ngoctp29121982, whose advice was very useful).
	The export of the activities to CSV files in this case is also updated (if there are constraints of type min half days between activities, they will be exported
	in a format compatible with the importing).
	- Code cleanup.
 6.7.3
	- Bug fix: when generating an impossible file on multiple threads, the program could hang (discovered with the help of math). The bug was isolated with the help
	of GDB (GNU Debugger).
	- Improved the generation on some locked timetables for which the program would report impossible generation, even if these files were solved when they were
	unlocked (reported by math).
 6.7.2
	- Updated to Qt 6.4.1.
	- Minor improvements.
 6.7.1
	- Crashing bugs fixed, when generating multiple on more threads (hopefully they are all fixed now, and hopefully no new ones are introduced. If you experience
	crashes or lockings of the program while generating single or multiple on more threads please report them).
	- Minor improvements.
 6.7.0
	- Added simple support for the credit hour system (American system) (suggested by Imad). The new feature is that you can add multiple constraints
	of type activities same starting hour / activities occupy max different rooms with a single click.
	- Corrected a few compiler warnings (some reported by Clang, some reported by the new Qt 6.4.0).
	- Updated the Russian translation, by Alexey Chernous.
	- Updated the Vietnamese translation, by Phạm Văn Quyền Anh.
 6.6.2
	- Minor bug fixes in the reporting of the soft conflicts, when having some types of time constraints related to inactive activities.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
	- Updated the Vietnamese translation, by Phạm Văn Quyền Anh, who is again the assigned translator (he translated also in the past).
 6.6.1
	- Added a complete Italian translation, by Francesco Rizzo, who is the new translator.
 6.6.0
	- Updated to Qt 6.3.2.
	- Added a new type of constraint in the Mornings-Afternoons mode, students (set)/teacher(s) min hours per afternoon (suggested by bachiri401 and Hocine Berrou).
	- Bug fixes when modifying/removing subjects/activity tags/students sets/teachers attached to constraints of type activities begin students'/teachers' day
	(reported by YOUSSEF HOUIET).
	- Updated the Russian translation, by Alexey Chernous.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
 6.5.7
	- Added a new type of constraint, teacher(s) max span per day, in the Mornings-Afternoons mode (suggested by Phạm Văn Quyền Anh). (This constraint type was
	already implemented for the other modes, but in the Mornings-Afternoons mode there was available only the constraint type teacher(s) max span per real day.)
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
 6.5.6
	- Added a new type of constraint: activity(ies) begin(s) students'/teachers' day (suggested by Henrique Belo).
 6.5.5
	- Added a new type of constraint, max half days between activities, in the Mornings-Afternoons mode (suggested by Mohamed Ait Ichou and fourat).
 6.5.4
	- Added a new type of constraint, teacher(s) min days per week, in the Mornings-Afternoons mode (suggested by Abdeljalil Elghazoui and Benahmed Abdelkrim).
	(This constraint was already available in the other modes, but in the Mornings-Afternoons mode there was available only the constraint type teacher(s)
	min real days per week.)
	- Added a new example file from Algeria, by Benahmed Abdelkrim.
	- Updated the Russian translation, by Alexey Chernous.
 6.5.3
	- Updated to Qt 6.3.1.
	- Minor interface bug fixes: in the timetable view teachers/students/rooms days horizontal, the cells marked with -x- or -X- were sometimes shown
	with bold, italic, or underlined font when changing the teacher/students set/room if there were locked activities in the timetable.
 6.5.2
	- Added a new type of constraint, students (set) max two activity tags from N1, N2, and N3 per day, in the Mornings-Afternoons mode
	(suggested by Ali Doussary).
	- Added a new type of constraint, teacher(s)/students (set) max two activity tags from N1, N2, and N3 per real day, in the Mornings-Afternoons mode
	(suggested by Ali Doussary).
	- Added a new type of constraint, teacher(s)/students (set) max building changes per real day, in the Mornings-Afternoons mode
	(suggested by Phạm Văn Quyền Anh and Ngọc Ngô Minh).
	- Improvements in the constraints teacher(s)/students (set) max two activity tags from N1, N2, and N3 per (real) day (in the Mornings-Afternoons mode).
	- Minor improvements for the Mornings-Afternoons mode, suggested by Ngọc Ngô Minh.
	- Updated the Vietnamese translation, by Ngọc Ngô Minh, who is the new translator.
 6.5.1
	- Bug fix in the Terms mode: decreasing the number of terms will now report the number of affected constraints (of type 'max terms between
	activities' and 'activities occupy max terms') and update them correctly.
	- Improved the teachers and students XML output timetable files, by including the id-s of the activities in the time slots (suggested by Fred).
 6.5.0
	- Important generation bug fix, when using constraints of type students (set) max span per (real) day. This bug was found with the help of
	Vangelis Karafillidis. Unfortunately, this bug fix means that the generation might take longer (for the contrived example
	FET-5-official/Romania/Pedagogic-High-School-Tg-Mures/2007-2008_sem1-d-test-students-max-span-per-day.fet the generation time might
	be even with 50% longer on average). But the algorithm is correct now and hopefully on real-life examples the behavior will be better;
	for this same contrived example, cycling (which is very very bad), which appeared when locking the activities to days, is not a problem anymore.
	- Bug fixes in the interface: when modifying the number of hours per half day in the Mornings-Afternoons mode, the constraints of type
	'max span per real day' were forced to reduce their maximum span to the number of hours per half day, not to the number of hours per real day.
	- Added two new types of constraints for the Terms mode: activities min in a term and max terms between activities (suggested by mikkojoo).
	- Added a new example file from Algeria, by Benahmed Abdelkrim.
 6.4.0
	- Improvement: now the algorithm won't put more than two subactivities from the same larger activity on the same day (real day for the
	Mornings-Afternoons mode), even if 'consecutive if same day' is not selected (suggested by Benahmed Abdelkrim). Unfortunately, some locked timetables
	might become impossible with this change - in this case please unlock them and generate again.
	- Added a new type of constraint in the Mornings-Afternoons mode: min half days between activities (suggested by ngoctp29121982, with a further
	suggestion by bachiri401).
	- Added the option to lock activities to their scheduled day, useful for timetables which change over the year, due to teacher arrival/leaving.
	This option is available in the students/teachers view timetable time horizontal dialogs. Suggested by Vangelis Karafillidis and Alexey Chernous.
	- Improved the behavior of the timetable view students/teachers/rooms days horizontal dialogs, as suggested by Vangelis Karafillidis.
	- Updated the Romanian translation, by Liviu Lalescu.
	- Updated the Russian translation, by Alexey Chernous.
	- Updated the French translation, by Pascal Cohen.
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 6.3.4
	- Minor improvements.
	- Minor correction in the Arabic translation, by Benahmed Abdelkrim.
	- Updated the Russian translation, by Alexey Chernous.
 6.3.3
	- Interface bug fix: when switching from a language with a right-to-left layout to one with a left-to-right layout, the interface layout remained
	right-to-left.
	- Code cleanup.
	- The Arabic translation will now use Western Arabic numerals (suggested by Walid and Benahmed Abdelkrim).
 6.3.2
	- Updated to Qt 6.3.0.
	- Minor improvements.
	- Updated the Russian translation, by Alexey Chernous.
 6.3.1
	- Updated to Qt 6.2.4.
 6.3.0
	- Added a new type of constraint in the Mornings-Afternoons mode: students (set) max three consecutive days (suggested by Benahmed Abdelkrim).
	- Improvement in the speed of generation in the Mornings-Afternoons mode.
	- Minor bug fixes.
 6.2.8
	- Minor improvements.
 6.2.7
	- Updated to Qt 6.2.3.
	- The font of the text of the interface is now customizable (suggested by Khelifi Fouad Mohssen). This font type will also be applied when printing
	the timetables (suggested by agemagician).
 6.2.6
	- Potential crash bug fix (most certainly not met in practice).
	- More detailed reports when reading a .fet file with wrong teachers, subject, activity tags, or students sets in the activities list. Suggested by math.
	- The search for updates on startup will now also send the current Qt version to the server.
 6.2.5
	- Added a new type of constraint, teacher(s)/students (set) min gaps between activity tag (suggested by uni_instructor and Thaneswer Patel).
	- Added an 'inverted' option for the filter in the activities and subactivities dialogs, to see the activities which are _not_ related to the
	selected filter (suggested by uni_instructor, with further suggestions by Volker Dirr).
	- The print preview dialogs will retain their size and position (suggested by Thaneswer Patel).
	- Corrected the US English original strings (many typos/small errors were found using Ispell / Aspell).
	- Corrected the Brazilian Portuguese translation, by Alexandre R. Soares (some typos/small errors were found using Ispell / Aspell).
	- Updated the Bulgarian translation, by Asen Pashov.
	- Updated the Russian translation, by Alexey Chernous.
 6.2.4
	- Updated to Qt 6.2.2.
	- Updated and corrected the Bulgarian translation, by Asen Pashov.
 6.2.3
	- Minor corrections in the documentation, reported by Alexey Chernous.
	- Added an initial partial Bulgarian translation, by Asen Pashov.
	- Updated the Russian translation, by Alexey Chernous (some typos/small errors were found using Ispell / Aspell).
	- Updated the Vietnamese translation, by Phạm Văn Quyền Anh, who is the new translator.
	- Corrected the Romanian translation, by Liviu Lalescu (the typos/small errors were found using Ispell / Aspell).
	- Corrected the Arabic translation, by Benahmed Abdelkrim (the typos/small errors were found using Ispell / Aspell).
 6.2.2
	- Updated to Qt 6.2.1.
	- Crash bugs fixed (rare, in the Mornings-Afternoons mode, if using constraints of type teacher(s)/students (set) min mornings/afternoons per week
	for teachers/students sets who had no activities). Reported by Abdul Latif Al-Ablaq, Hisham Abu Ferdous, and Ahmed Moullafi (Ahmed Moullafi provided
	an input file which was very useful in isolating the bugs).
 6.2.1
	- Improvements of the efficiency of generation in the constraints teacher(s) min hours daily per real day (in the Mornings-Afternoons mode).
	- Updated the Arabic translation, by Benahmed Abdelkrim.
	- Updated the Russian translation, by Alexey Chernous.
 6.2.0
	- Crash bugs fixed, when restoring the default settings (probably very rare).
	- Corrected a bug regarding the efficiency of generation in the constraints teacher(s) min hours daily per real day (in the Mornings-Afternoons mode)
	(discovered using the new Clang 13.0.0).
	- Minor corrections in some texts of the interface.
	- Updated the Romanian translation, by Liviu Lalescu.
 6.1.8
	- Updated to Qt 6.2.0.
	- Improvements in the new constraint introduced in the previous version (teacher(s) max three consecutive days).
	- Minor interface bug fixes.
 6.1.7
	- Added a new type of constraint in the Mornings-Afternoons mode: teacher(s) max three consecutive days (suggested by Benahmed Abdelkrim, Hiba Hadi,
	and other users).
	- Added a new example file from Algeria, by Benahmed Abdelkrim.
 6.1.6
	- Updated to Qt 6.1.3.
	- Possible crash bugs fixed (probably never met in practice).
	- Improvement in the timetable generate multiple dialog: showing the number of successfully generated timetables (useful for instance when generating
	with a time limit).
 6.1.5
	- Crash bug fixed, when using the constraint teachers max gaps per morning and afternoon (in the Mornings-Afternoons mode) (reported by hellal sofiane yazid).
	- Now also the subgroups' XML timetables are saved in ordered form, if the user selected this option.
	- Code and interface improvements.
 6.1.4
	- Added a new constraint, two sets of activities are ordered (suggested by math and Volker Dirr).
	- Added the option to sort alphabetically the subgroups in the view/print/HTML timetables (suggested by math).
	- Minor improvements (some of them were suggested by math).
 6.1.3
	- Added the constraints of type teacher(s) max gaps per morning and afternoon (in the Mornings-Afternoons mode) (suggested by ghani1990).
	- Added the constraints of type teacher(s)/students (set) begin mornings early max beginnings at second hour (in the Mornings-Afternoons mode)
	(suggested by bachiri401).
	- Improved the visual aspect of the teachers and students time constraints lists in the Mornings-Afternoons mode (suggested by bachiri401, Benahmed Abdelkdrim,
	and Khineche Kaddour). Also it was improved the visual aspect of the activities time constraints.
	- The dialogs of adding constraints of type two activities ordered, two activities ordered if same day, two activities consecutive, two activities grouped,
	and three activities grouped were improved. Now there are selected different activities (the first two or three ones), not only the first. Suggested by math.
	- Updated the French translation, by Pascal Cohen.
 6.1.2
	- Enabled the constraints of type teacher(s)/students (set) activity tag min hours daily in the Mornings-Afternoons mode (suggested by
	Khineche Kaddour, YOUSSEF HOUIET, and other users).
	- Added a new example file from Algeria, by Benahmed Abdelkrim.
 6.1.1
	- Crash bugs fixed, when using the constraints teacher(s) max two activity tags from N1, N2, and N3 (in the Mornings-Afternoons mode)
	and there were activities having none of these tags. Reported by Mohamed Ait Ichou. Other minor bugs were fixed in these constraints
	(the description of the constraints, and an activity should not have more than one tag from these three, if using these constraints relating
	to its teacher(s)).
 6.1.0
	- Updated to Qt 6.1.2.
	- Added the import/export of comments from/to CSV (comma separated values) files (suggested by Darren McDonald).
	- Added two new example files from South Africa, by Eric Carolus.
	- Updated the Russian translation, by Alexey Chernous.
 6.0.4
	- Updated to Qt 6.1.1.
	- Bug fix in the timetable generate multiple dialog, when generating on multiple threads: if the generation time limit was reached and if the limit
	on the total number of generated timetables was reached, the highest-stage solutions of some of the timetables generated in the last round were missing
	in the final results.
 6.0.3
	- Updated to Qt 6.1.0.
	- Code cleanup.
	- Added three new example files, by Jijo Jose (two from India and one from South Africa).
 6.0.2
	- Crash bugs fixed when using Qt 5.15.2, reported by ghani1990. The exact locations with wrong code were found using gdb.
	- Bug fix: the program was using some uninitialized variables (discovered with Valgrind). But this did not affect the generation.
 6.0.1
	- Bug fix when importing the teachers from a CSV file in the mornings-afternoons mode. This bug would eventually lead to a crash
	(assertion failed) when viewing the teachers list. Reported by Khineche Kaddour.
 6.0.0
	- Updated to Qt 6.0.3.
	- Increased the limits of the generation algorithm (the new limits are most probably more than enough for everybody).
	- Combined the most important custom versions into the official FET. The new feature is called "mode" and it can be:
	"official", "mornings-afternoons" (for Morocco and Algeria), "block planning", and "terms" (for Finland).
	- The multiple generation can be done on multiple threads, each timetable on a separate thread. Multiple timetables should
	be obtained much faster if you have a multi-core/hyper-threading processor.
	The following people, listed in chronological order, contributed to this release: bachiri401 (thorough testing), Alexey Chernous (testing),
	Darren McDonald (testing and bug reports), DT (suggestions), Chichi Lalescu (suggestions), YOUSSEF HOUIET (testing and bug reports),
	and the translators: Benahmed Abdelkrim (Arabic), Robert Hairgrove (German), Alexandre R. Soares (Brazilian Portuguese),
	Alexey Chernous (Russian), Vangelis Karafillidis (Greek), and Emiliano Llano Díaz (Spanish).
 5.49.1
	- Minor fix/improvement in the colors of the timetables.
	- Redesigned the locked/unlocked icons for the special constraints.
	- Acknowledged the code contributors in a new file, CONTRIBUTORS, and in a new section in Help->About FET, Contributors.
	- Minor improvements.
 5.49.0
	- It is now possible to use any number of constraints of type teacher(s)/students (set) interval max days per week for a teacher/students set
	(previously this number was limited to maximum three for each teacher/students set).
	- It is now possible to reset the number of categories of a students year to zero in the divide year dialog (suggested by Eric Carolus).
	- Code improvements and cleanup.
	- Added an updated example file from South Africa, by Eric Carolus, replacing a deprecated example file.
 5.48.2
	- Code improvements and cleanup (including one improvement suggested by Volker Dirr, found using Coverity Scan).
 5.48.1
	- Corrected a compilation error on 32-bit platforms (reported by Zsolt Udvari).
	- Code cleanup (suggested by Volker Dirr, found using Cppcheck).
 5.48.0
	- Updated the code to be compliant with the future Qt 6.0.0 (suggested by Volker Dirr).
 5.47.1
	- Updated to Qt 5.15.2.
	- Corrected a few warnings appearing with the new Qt 5.15.2 (about using deprecated Qt functions).
	- Corrected three minor warnings when compiling with clang.
	- Minor improvements in the text description of the activities.
	- Code cleanup.
	- Added a new example file from Spain, by Fran.
 5.47.0
	- Updated to Qt 5.15.1.
	- Theoretical improvement/logic bug fixed in the generation when using constraints of type students (set) early max beginnings at second hour without
	max gaps constraints or with more than zero max gaps allowed.
	- Added a warning if using constraints of type teacher(s)/students (set) max hours daily with weights less than 100%, because the algorithm
	is not perfectly implemented in this case.
	- The automatic division of years by categories will now retain the settings for each year, separately (suggested by Eric Carolus and possibly other users).
	- Minor code improvements (suggested by Volker Dirr).
 5.46.1
	- Increased the maximum number of hours per day to 72 (suggested by Celia22).
	- Added help/information in the add/modify constraint activity preferred room dialog (suggested by math).
	- Minor improvements.
 5.46.0
	- Added a new feature to create easier overlapping groups/years, from the subgroups/groups dialogs (suggested by samantha.goddard's file).
	- Added the possibility of executing an external command after the generation (suggested by Zsolt Udvari and other users). The implementation of this feature
	was inspired by the Claws Mail software.
	- Added a new example file from Hong Kong, by Marcus.
 5.45.1
	- Minor fixes and code cleanup.
	- Added a new example file from South Africa, by Eric Carolus.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 5.45.0
	- Slightly improved the code for the constraints of type teacher(s)/students (set) max days per week and teacher(s)/students (set) interval max days per week.
	- Corrected a compilation warning appearing with the new gcc 10.1.1.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 5.44.9
	- Corrected the source files of the application icons and generated higher resolution ones (suggested by Darren McDonald, using additional suggestions
	from Vangelis Karafillidis and DT). The application icon in the icns format (used on Mac OS X) was contributed by Darren McDonald.
	- The application name is now set correctly (using a solution found by Darren McDonald).
 5.44.8
	- Updated to Qt 5.15.0.
	- Code cleanup.
 5.44.7
	- Code improvements/cleanup in the generate function.
 5.44.6
	- Minor fixes in the all time/space constraints dialogs.
	- Removed the warning that was issued when the user selected a higher HTML level for the generated timetables (if the selected HTML level was 3 or higher,
	the program warned of possible large file sizes).
	- Minor code improvements.
	- Code cleanup.
 5.44.5
	- Minor fixes and code cleanup.
 5.44.4
	- Bug fix: the program froze when hiding rows or columns in the activity planning dialog. This bug was introduced in version 5.43.0. Reported by Dietmar Deuster.
	- Code improvements.
 5.44.3
	- Minor fixes and code cleanup.
 5.44.2
	- Bug fix: when using constraints activity tags not overlapping with the activity tags names containing the special characters &, >, or < (and possibly " or '),
	the saved file would be corrupted and could not be reopened without firstly correcting it manually. Reported by Darren McDonald.
 5.44.1
	- Updated to Qt 5.14.2.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
	- Minor fixes.
 5.44.0
	- Changed the random number generator to a better one, MRG32k3a, by Pierre L'Ecuyer (used with permission). This has a longer period but, unfortunately,
	on some older/not so powerful computers/platforms (especially the 32-bit ones), this new random number generator might run (much) slower. But the generation
	time should be generally nearly the same or comparable, since the random numbers generation routine seems to take only about 3% of the generation time.
	- Bug fix for the future Qt versions: Qt reverted back from the signal QComboBox::currentIndexChanged(int, const QString &) used in their snapshot
	to the signal QComboBox::currentIndexChanged(int). The combo boxes should now work correctly with the future versions of Qt.
	- Code cleanup.
 5.43.2
	- Corrected a compiler error appearing with the future Qt versions (this bug was introduced in FET version 5.43.0: the function
	QNetworkReply::error() will not be obsolete and the replacement function QNetworkReply::networkError() was dropped. So we needed
	to revert this also in the FET code, otherwise we would get a compiler error with the future Qt versions).
	- Updated the code for the future Qt versions: removed usage of the soon-to-be obsolete constant QString::SkipEmptyParts
	(the future constant will be Qt::SkipEmptyParts).
 5.43.1
	- Minor bug fix: the constraint students (set) max days per week allowed a minimum value of 0 max days per week. Now the minimum value is correctly 1.
	Reported by bachiri401.
	- Slightly improved the dialogs for the constraints of type activity/subject/activity tag/subject+activity tag preferred room(s) (suggested by bachiri401).
	- Code update/cleanup.
 5.43.0
	- Updated the code for the future Qt versions: removed usage of QLinkedList, of Java-style iterators, of the soon-to-be obsolete function
	QNetworkReply::error(), and of some obsolete Qt signals, and changed from endl to Qt::endl in the necessary places.
	These changes are not visible to the user.
	- Many code improvements/cleanup in the interface part.
	- Exporting of the advanced statistics to the disk now centers the text contents of the table cells.
	- Improved the command-line usage instructions (suggested by Zsolt Udvari). They are now easier to read. Also, running the command-line
	version will create log/results files/directories only if an input file is given.
 5.42.3
	- Updated to Qt 5.14.1.
	- When opening a file containing unrecognized XML tags, FET will issue a warning and indicate their locations. Reported by math.
	- Minor fix/improvement for the Mac OS X version: the "About FET" menu item was shown/executed incorrectly (reported by Darren McDonald and math).
	Also, with this occasion, the "Quit" menu item was linked to the specific recommended menu place for this platform.
	- Minor improvements.
	- Updated the Spanish translation, by Emiliano Llano Díaz.
 5.42.2
	- Minor improvements.
 5.42.1
	- Bug fix: the command-line version of FET did not remove the file logs/difficult_activities.txt before a new generation, if it was written
	by a previous unsuccessful generation.
	- Minor code improvements and cleanup.
	- Added more proper acknowledgments and references for the used libraries.
 5.42.0
	- Updated to Qt 5.14.0.
	- Corrected many warnings appearing with the new Qt 5.14.0 (about using deprecated Qt functions).
	- Minor speed improvements when using the constraints involving room/building changes for students/teachers.
	- Crash bug fixed when reading a file which was not in the FET XML format (probably not met in practice). Now FET reports that it is an
	incorrect file.
	- Bug fix: when opening the students' timetable view days horizontal dialog with the subgroups list variant selected, the details for the
	current activity were not shown. Also, in this case, locking the selected activities did not work. Reported by math.
	- Minor bug fixes in the activity planning dialog: when swapping the teachers/students, their initial order in the related activities
	might not have been preserved.
	- Code cleanup.
 5.41.0
	- Implemented these types of constraints: teacher(s)/students (set) activity tag min hours daily (suggested by Chafik Graiguer, Pietro,
	Vangelis Karafillidis, Benahmed Abdelkrim, s.lanore, and maybe other users). These constraints types are not perfect and must be enabled
	from the settings menu.
	- Implemented the constraint type activities occupy min time slots from selection (suggested by flauta, Vangelis Karafillidis, and math).
	- Implemented the constraint type activities min simultaneous in selected time slots (suggested by Vangelis Karafillidis).
	- Implemented these types of constraints: teacher(s)/students (set) max room changes per day/week, and teacher(s)/students (set) min gaps
	between room changes (suggested by Benahmed Abdelkrim, abdeljalil elghazoui, otman hashem, Ahmed El Hawary, Abdellah Sabri, khatou1973,
	nachrach111, Omar Ben Ali, forstera, and maybe other users).
	- Code improvements in the generation code of the constraints of type teacher(s) max span per day when allowing a one day exception of
	max span plus one.
	- Code improvements in the generation code of the constraints of type activities occupy max time slots from selection
	and activities max simultaneous in selected time slots.
	- Improved the activity planning dialog, by Volker Dirr (one improvement - to swap the students sets - was suggested by uni_instructor).
	- The activity planning dialog is now accessible by a keyboard shortcut (Ctrl+A in English, maybe other letters in other languages)
	(suggested by uni_instructor).
	- Removed a useless computation that was done after the generation (suggested by Marco Diego Aurélio Mesquita).
	- Various other code improvements/cleanup.
	- Added a new example file from Algeria, by Lysso.
 5.40.3
	- Updated to Qt 5.13.2.
	- Code cleanup.
	- Added two new example files from Syria, by Zafar Allah Askar.
 5.41.0
 5.40.2
	- Various rare but important bug fixes concerning the new feature of virtual rooms.
	- Small memory leak bug fixed (when reading incorrect files with virtual rooms).
	- Minor fixes and improvements.
	- Added a new example file from Greece, by dimzev.
 5.40.1
	- Bug fix: if using virtual rooms, when generating a new timetable and locking it, some constraints of type activity preferred room could be added again,
	even if they were already present, if the real rooms chosen for the virtual room were the same but in a different order (the order should not matter).
 5.40.0
	- Updated to Qt 5.13.1.
	- Added virtual rooms, which give the possibility for the user to specify more rooms for an activity, or to choose between a large room or more smaller
	rooms for an activity, and might open the possibilities for other kinds of usage. Suggested by math on the forum, who had some very useful ideas.
	These users also suggested more rooms for an activity: Volker Dirr, Anton Anthofer, dasa, Thaneswer Patel, and amin.
	Unfortunately, this feature might make FET about 5-10% slower even if you are not using virtual rooms, and I apologize for this,
	but virtual rooms are useful.
	- Added the possibility to allow a one day exception of max span plus one for the constraints of type teacher(s) max span per day
	(suggested by totera, Luca, and bachiri401).
	- Bug fix: now it is not allowed to run FET command-line on files which do not contain any activity.
	- Minor bug fix when using constraints with weights having 5 or 6 digits after the decimal dot (like 99.999975%). This minor bug did not affect
	the generation, only the final report of the (soft) conflicts.
	- Minor bug fix in the import of the rooms and of the buildings, by Volker Dirr.
	- Added a new example file from Romania, by rapsy.
 5.39.0
	- Added a new type of constraint: activity tags not overlapping (suggested by Henrique Belo).
	- Speed improvement in the pre-generation routine, if the data file contains constraints of type activities not overlapping.
 5.38.1
	- Updated to Qt 5.13.0.
	- Very rare crash bug fixed, when executing fet-cl on an incorrect input file with the option to export the CSV files. Reported by Xingxing.
	- Code cleanup (fixed some compiler warnings which appeared with the new Qt 5.13.0).
 5.39.0
 5.38.0
	- Updated to Qt 5.12.3.
	- Added a new type of constraint: min gaps between an ordered pair of activity tags for a students set / all students / a teacher / all teachers,
	suggested by Nagendra and other users.
	- Bug fixes and code cleanup.
	- Minor bug fix: the modify constraint room not available times dialog did not allow the weight to be set to 0%, a value which should have been permitted.
	Reported by math.
	- Added two new example files from Hungary, by Madas Pál.
	- Added a new example file from Tunisia, by fourat.
	- Added a new example file from India, by Nagendra.
 5.37.5
	- Minor improvement (automatic check for updates also sends to the server the user's processor architecture type, as other programs usually do) - suggested
	and implemented by Volker Dirr.
	- Updated the translations.
 5.37.4
	- Automatic check for updates on startup is working correctly now (using fixes found on Stack Overflow and on Amin Ahmadi's site).
 5.37.3
	- Updated to Qt 5.12.0.
	- When compiling with Qt 5, FET uses the better QRegularExpression class instead of the deprecated QRegExp class (which is only used if the user
	compiles with the old Qt 4).
	- Crash bug fixed when adding a constraint min days between activities and the number of the days per week is 1 (probably very rare).
	- Improved the import: the automatic selection of fields will now work even if there is no text quote around the fields (suggested by Jude G,
	implemented by Volker Dirr).
	- Minor string fixes in the CSV import/export dialogs.
	- Minor improvement: the attributes of the file fet.desktop, found in the sources archive of FET, were corrected.
 5.37.2
	- Fixed a compilation problem when using Qt >= 5.0.0 and < 5.7.0. Reported by yakup.
	- Crash bug fix (usually not met in practice), when opening a file containing duplicate activities id-s. Reported by Ahmed Ben Hassan.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
	- Volker Dirr's site now uses SSL (https protocol instead of http).
 5.37.1
	- Rare crash bug fixed, appearing when viewing the timetable, then modifying some data (like increasing the number of days per week or hours per day)
	without closing the timetable view dialogs, and then regenerating. Reported by liquid.
	- The opened timetable view dialogs are now better updated after a successful or unsuccessful generation (suggested by Volker Dirr).
	- The constraints of type subactivities preferred starting times and subactivities preferred time slots now include a 'duration' filter (suggested by
	Léo-Paul Roch and Volker Dirr).
	- The limit for the maximum number of generated timetables in a multiple generation is increased from 100 to 1000 (suggested by Volker Dirr).
	- Code cleanup (suggested by Volker Dirr).
 5.37.0
	- Code update: removed the dependency of the obsolete Qt 'foreach' keyword (suggested by Volker Dirr). The speed of generation is improved by 5%-25%,
	depending on the data file. Now you need a C++11 compliant compiler to compile FET.
	- Updated the German example files from secondary school 1, by Volker Dirr.
	- Updated all the example files to use the latest file format.
 5.36.2
	- When viewing the activity details in the timetable view dialogs, if a room is allocated for this activity, there will also be shown the
	building and the capacity of this room (suggested by Diego Froner).
	- Added the feature of locking and unlocking all the activities having attached a certain activity tag (suggested by Diego Froner).
	- Bug fix in the unlocking of activities of a certain day if the timetable was not generated: If the user selected only space unlocking, no activities
	were unlocked.
 5.36.1
	- Updated to Qt 5.11.1.
	- The add activity, modify activity, and modify subactivity dialogs now have an option to show all the teachers or only the qualified teachers for
	the chosen subject (suggested by Volker Dirr).
	- The main check boxes and radio buttons in the activities, subactivities, add activity, modify activity, and modify subactivity dialogs now save
	and restore their state (suggested by Volker Dirr).
	- Added information about potential privacy issues if enabling the 'Search for updates on startup' option.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 5.35.7
	- Updated to Qt 5.11.0.
	- Corrected a few compilation warnings that appeared in FET when using the new Qt 5.11.0.
	- Code cleanup (by Volker Dirr).
	- Improved the command-line operation on Windows (since this platform misses/ignores SIGTERM, we use instead SIGBREAK to write the current and
	highest-stage timetables, then stop the program). Suggested by svenvanhal.
 5.36.0
	- Added a new constraint, two activities are ordered if they are on the same day (suggested by math).
	- The students' combo boxes can now be shown in three styles: simple (the old style), with icons, or categorized (suggested by math).
	- The view students' timetable days horizontal dialog was improved. Now the user can see the timetable for each year/each group/each subgroup (as before),
	for all years/each group/each subgroup, or for all years/all groups/each subgroup. Suggested by math.
	- The languages dialog now contains the untranslated description of each language (suggested by Volker Dirr).
	- Corrected a command-line bug: argument '--warnifusinggroupactivitiesininitialorder=true|false' was ignored. Reported by svenvanhal.
	- Corrected two compilation warnings (reported by Innocent De Marchi).
	- Corrected two bugs in the German translation (reported by math).
	- Corrected a few bugs in the translations.
 5.35.6
	- Minor strings bugs fixed (reported by Vangelis Karafillidis).
	- Updated the Greek translation, by Vangelis Karafillidis. It is now complete.
 5.35.5
	- Bug fix when using the old Qt 4: the special characters in the Help->About dialog were incorrectly displayed (bug introduced in the previous version, 5.35.4).
	- Minor fix: the example file translations/test-all-constraints.fet which should contain all the types of constraints was missing two of them. Corrected.
	- Updated the Greek translation, by Vangelis Karafillidis.
 5.35.4
	- Fixed two compilation errors under the Microsoft Visual C++ compiler (reported by Volker Dirr). Now FET can be compiled with this compiler.
	- The Help->About dialog of FET is now easily translatable into other languages (suggested by Rodolfo Ribeiro Gomes, Innocent De Marchi, and other users).
	- Minor string bug fixed (reported by Vangelis Karafillidis).
	- Updated the Greek translation, by Vangelis Karafillidis.
	- Added a new example file from Brazil, by francescotorres.
 5.35.3
	- Updated to Qt 5.10.1.
	- Minor strings bugs fixed (reported by Vangelis Karafillidis).
	- Updated the Catalan translation (which is now complete), by Innocent De Marchi, who is the new translator.
	- Updated the Japanese translation, by Taro Tada.
	- Updated the Greek translation, by Vangelis Karafillidis.
 5.35.2
	- Minor strings bugs fixed (reported by Innocent De Marchi).
	- Updated the Turkish translation, by Yakup Kadri Demirci, who is the new translator.
	- Updated the Greek translation, by Vangelis Karafillidis.
	- Updated the Japanese translation, by Taro Tada.
 5.35.1
	- The alphabetic sorting of the items now respects the user's locale (the special characters are better ordered).
	Suggestions and code by Rodolfo Ribeiro Gomes. Also, there were used suggestions and code found on qtcentre.org, in a post by ChrisW67.
	- Improved the translation procedure of some fields. Suggestion and code by Rodolfo Ribeiro Gomes.
	- Minor strings bugs fixed (reported by Vangelis Karafillidis).
	- Improvement in the Romanian translation: instead of a cedilla, the special characters ș, ț, Ș, and Ț now use a small comma beneath them
	(as recommended by dexonline.ro and cum-scriem-corect.blogspot.ro).
 5.35.0
	- Bug fix: when unplugging a display, the dialogs which were previously shown on this display were not shown correctly on the remaining active display(s)
	(instead, they were invisible). Reported by kdrosos and sigit_yuwono.
	- Minor bugs fixed (reported by Vangelis Karafillidis).
	- Added a partial Japanese translation, by Taro Tada.
	- Added a new partial Greek translation, by Vangelis Karafillidis, who is the new translator.
	- Updated the Czech translation, by Pavel Fric.
 5.34.3
	- Minor corrections in the Romanian translation, by Liviu Lalescu.
 5.34.2
	- Corrected the style/appearance of precompiled FET for Windows 7 (added a missing DLL).
 5.34.1
	- Updated to Qt 5.10.0.
	- Corrected a compilation warning that appeared in FET when using the new Qt 5.10.0 (class QSignalMapper is now deprecated).
 5.34.0
	- Improved the activity planning dialog, by Volker Dirr. Now the user can swap the teachers of one or more activities.
	- Added the possibility of exporting the data and the timetable as CSV (comma separated values) files from the command line version of FET
	(suggested by Matthias Söllner and m).
 5.33.3
	- Updated the Spanish translation, by Emiliano Llano Díaz.
	- Code cleanup.
 5.33.2
	- Updated to Qt 5.9.2.
	- Added a new complete Spanish translation, by Emiliano Llano Díaz, who is the new translator.
	- The homepage of FET was updated to use SSL (https protocol instead of http).
	- Code cleanup.
 5.33.1
	- Bug fix: when moving rooms/buildings up/down in their corresponding dialogs, the description on the right was not updated correspondingly.
	Reported by chernous.
 5.33.0
	- Very rare but important generation bug fixed. In some cases, for feasible timetables, the generation might cycle incorrectly. This is an old bug,
	affecting files with constraints students/teachers max hours daily and max gaps per day/week, but nobody observed it until now. Reported by Volker Dirr.
	A big 'Thank you!' to Volker, for being very supportive in hunting down this bug.
	- Added the number of working hours for the teachers and the students in the HTML timetables statistics (suggested by Fernando A F Lordão, implemented by
	Volker Dirr).
	- Added a new Algerian example file, by Benahmed Abdelkrim.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 5.32.3
	- Code cleanup (by Liviu Lalescu and Volker Dirr).
	- Updated the Brazilian Portuguese translation, by Alexandre R. Soares.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 5.32.2
	- Crash bug fixed (rare, if adding an activity without students sets which had a specified number of students greater than 0). Reported by Zsolt Udvari.
 5.32.1
	- Corrected a few compilation errors on older compilers (reported by Valdo, fixed by Rodolfo Ribeiro Gomes and Liviu Lalescu).
	- Implemented the rooms' timetable view time horizontal from the FET interface (suggested by sigit_yuwono).
	- In the timetable view time horizontal dialogs the activities which are locked in space are shown with an italic font (suggested by Vangelis Karafillidis).
 5.32.0
	- Implemented the teachers' and students' timetable view time horizontal from the FET interface, for easier locking/unlocking/generating a partially locked timetable.
	Suggested by Vangelis Karafillidis, who did a great job with his useful suggestions and reports. Also Volker Dirr had some useful suggestions for this new feature.
	- Added the en_GB (British English) locale, so that the date/time in the generated timetables can be shown in British format (suggested by rjmillett. It was also
	previously suggested by Mr Robo).
 5.31.9
	- Bug fix in the German translation. Reported by math, corrected by Bob Hairgrove.
 5.31.8
	- Bug fix: when importing rooms without any building from a CSV file there were added no rooms to the data. Reported by Robinson A. Lemos and Maurino C. Maria,
	fixed by Volker Dirr.
 5.31.7
	- Updated to Qt 5.9.1.
	- Added filters in the following dialogs of constraints for activities: same starting day, same starting hour, two activities ordered,
	two activities consecutive, two activities grouped, three activities grouped (suggested by math).
	- Added the possibility to swap the two selected activities in the add/modify constraint dialogs for the constraints of type two activities ordered and
	two activities consecutive (suggested by math).
	- Updated the German translation, by Volker Dirr.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 5.31.6
	- Bug fix (if there were used subjects containing the special characters &, ", >, <, and ', and if there were teachers having as qualified subjects
	these subjects, FET could not open the .fet data file anymore) - reported by bart.leyen.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 5.31.5
	- Rare crash bugs fixed. These bugs appeared when removing a teacher/students set with attached constraints not available. Reported by Benahmed Abdelkrim.
	- Updated the Arabic translation, by Benahmed Abdelkrim.
 5.31.4
	- Bug fix in the printout of the subjects' timetables (reported by math user).
	- Updated the Arabic translation, by Benahmed Abdelkrim and Silver.
 5.31.3
	- Speed improvement in the precomputation if using many rooms and many buildings.
	- Updated the Arabic translation, by Benahmed Abdelkrim. It is now complete.
 5.31.2
	- Each activity tag now has an additional property, "Printable", so that you can show/hide each individual activity tag in the HTML timetables and in
	the printout of the timetables from the interface (suggested by Malamojka, Rodolfo Ribeiro Gomes, and math user).
	- Bug fixes in the HTML timetables and in the printout of the timetables from the interface (reported by Volker Dirr and math user).
	- Added a new example file from Russia, by Julio González Gil.
	- Added a new anonymous example file, by Matsumoto.
 5.31.1
	- Bug fix: when importing rooms and buildings from CSV (comma separated values) files, if some rooms were in the same building, the building was added
	more times. Reported by Abou, fixed by Volker Dirr and Liviu Lalescu, along with other minor import things.
	- When the user selects the filter in the all time/space constraints dialogs, the first line edit will get focus and its text will be selected,
	for easier navigation with the keyboard. Suggested by math user.
 5.31.0
	- Updated to Qt 5.8.0.
	- Added a new type of constraint: teacher(s)/students (set) max span per day (the maximum time spent in the institution on a day).
	Suggested by Vangelis Karafillidis and Rodolfo Ribeiro Gomes (Rodolfo Ribeiro Gomes contributed an initial code for the constraints of type teacher(s)
	max span per day).
	- Added a new type of constraint: teacher(s)/students (set) min resting hours (the minimum free time slots between the last working hour on a day and
	the first working hour on the next day). Suggested by Rodolfo Ribeiro Gomes, who contributed an initial code for the constraints of type teacher(s)
	min resting hours.
	- Fixed some typos in the German translation (reported by math user, corrected by Bob Hairgrove).
	- Added 3 new example files from Namibia, by Bobby Wise.
 5.30.8
	- Updated to Qt 5.7.1.
	- A few Brazilian Portuguese translation bugs corrected (reported by Rodolfo Ribeiro Gomes, fixed by Alexandre R. Soares).
 5.30.7
	- Minor bug fix: when importing a file with 0 activities, there appeared a useless progress dialog. Also in other places with 0 data there might have appeared
	a useless progress dialog. Reported by Malamojka.
 5.30.6
	- FET command-line now writes the impossible activity and the current and highest-stage timetables (which should be identical) after an impossible
	generation (suggested by thanhnambkhn).
	- Minor bug fix: when importing data from CSV, skipping the activity if its duration is less than 1 (reported by Malamojka, fixed by Volker Dirr).
 5.30.5
	- Minor bug fix in the HTML timetables, by Volker Dirr.
	- Updated the Arabic translation, by Silver.
 5.30.4
	- Minor bug fix in the HTML timetables (reported by ant7, fixed by Volker Dirr).
	- Reporting the number of broken (soft) constraints (suggested by Volker Dirr and mercurialuser).
	- Added a new example file from United Arab Emirates, by Darren McDonald.
 5.30.3
	- Generating the activity tags timetables (suggested by Darren McDonald, implemented by Volker Dirr).
	- Added comments for teachers, students, subjects, activity tags, rooms and buildings (suggested by Volker Dirr and Anton Anthofer, implemented by Liviu Lalescu).
	- Very rare crash bugs fixed (reported by mouiata).
	- Added a new example file from Indonesia, by wahyuamin.
 5.30.2
	- Added more checks before the generation start (suggested by Léo-Paul Roch and Volker Dirr).
	- Very rare bug fixed (probably never met in practice).
 5.30.1
	- Interface improvement: the shortcut buttons on the main form are better arranged (suggested by math user).
 5.30.0
	- Bug fix: the 'Activities rooms statistics' did not work correctly: it considered even inactive constraints (reported by math user).
	- Added the possibility of selecting whether to print the detailed or the less detailed HTML timetables for the groups and years (suggested by math user,
	implemented by Volker Dirr and Liviu Lalescu).
	- Added the possibility of selecting whether to print the detailed or the less detailed HTML timetables for the free periods of the teachers (suggested by
	Volker Dirr and implemented by Volker Dirr and Liviu Lalescu).
	- Added the target number of hours for teachers (suggested by Volker Dirr and implemented by Volker Dirr and Liviu Lalescu).
	- Added the teachers' qualification to teach certain subjects, and the statistics to show where the qualification of a teacher for a subject is not respected
	 (suggested by Volker Dirr and implemented by Liviu Lalescu).
	- Added 12 new example files from Namibia, by Bobby Wise.
 5.29.6
	- Updated to Qt 5.7.0 (thus, the Windows version now uses MinGW 5.3.0).
 5.29.5
	- Updated to Qt 5.6.1.
	- Rare crash bug fix in the activity planning form (reported by Benahmed Abdelkrim).
 5.29.4
	- Updated the sources to gcc-6.1.1 (but the Windows version still uses MinGW 4.9.2).
	- The code in the HTML timetables tries to avoid page breaks in the tables (suggested by Benahmed Abdelkrim, implemented by Volker Dirr).
 5.29.3
	- Code cleanup.
	- Corrected two minor typos in the source code (reported by Alexandre R. Soares).
 5.29.2
	- Crash bugs fixed - the program crashed when renaming teachers/students and removing their attached constraints not available times
	(reported by Wizard).
	- Brazilian Portuguese translation update, by Alexandre R. Soares. It is now complete.
	- Code cleanup (improvements found by Volker Dirr using Cppcheck 1.73).
 5.29.1
	- The method of selection of the categories of timetables to be written on disk after generation is now improved (suggested by Alexandre R. Soares).
	- Brazilian Portuguese translation update, by Alexandre R. Soares.
 5.29.0
	- Updated to Qt 5.6.0.
	- Added the possibility of automatic coloring of the HTML timetables, using the HTML level 7 in the "Settings/Timetables" menu.
	Also, the user can color the timetables in a similar way from the "Timetable print" dialog.
	(Suggested by Handaya, hudrea and Udo Schütz, implemented by Volker Dirr and Liviu Lalescu, using also code by Marco Vassura.)
	- Code cleanup.
	- Brazilian Portuguese translation update, by Alexandre R. Soares.
	- Added a new Indian example file, by Jijo Jose.
	- Added two new Namibian example files, by Bobby.
 5.28.6
	- The user can now change the order of the teachers, students, subjects, activity tags, buildings, rooms, time constraints, and space constraints
	from the interface (suggested by Volker Dirr).
	- Added a new Indian example file, by Sudharshan K M and Nataraj Urs H D.
 5.28.5
	- Bug fix: not allowing the file name to end with white space(s), as this may lead to errors (reported by Volker Dirr).
 5.28.4
	- Bug fix: not allowing the file name to start with white space(s), as the HTML results do not work (reported by Volker Dirr).
	- Updated the Arabic translation, by Silver.
 5.28.3
	- After a successful single generation (or after an impossible one), an attention sound will be emitted. Also, after all the timetables finished
	(successfully, impossibly, or with time limit exceeded) in a multiple generation, the same attention sound will be emitted (suggested by Maouhoub
	and uni_instructor).
	- Updated the Vietnamese translation, by Nguyễn Hữu Duyệt.
	- Updated the Arabic translation, by Silver.
	- Added a new Vietnamese example file, by Nguyễn Hữu Duyệt.
	- Added a new Namibian example file, by Bobby.
 5.28.2
	- Updated to Qt 5.5.1.
	- Source cleanup.
 5.28.1
	- Crash bug fix when the input file contained activities with duplicate students sets / teachers and the user
	renamed these students sets / teachers (reported by Volker Dirr).
	- When renaming a students year, the user can choose to rename also automatically the groups and subgroups
	contained in this year (suggested and implemented by Volker Dirr).
	- Added colors when viewing the timetable from the interface, if the option to use colors in the interface
	is selected (suggested and implemented by Marco Vassura).
 5.28.0
	- Crash bugs fixed (reported by Davide Cottignoli).
	- Removed useless CONFIG += thread from src.pro and src-cl.pro (reported by locutusofborg).
	- Corrected a few typos in the Italian translation, by flauta.
	- Updated the Italian translation, by Marco Barsotti.
 5.27.9
	- Corrected some typos (reported by locutusofborg).
	- Added a section Keywords in the fet.desktop file (reported by locutusofborg).
 5.27.8
	- Corrected a compilation bug under Qt ( >= 5.0 and < 5.3 ) (reported by Michel).
 5.27.7
	- Added a partial Basque translation, by Asier Urio Larrea.
	- Added a partial Czech translation, by Pavel Fric.
	- Improvement in the all time / space constraints dialogs: you can press activate / deactivate / modify the constraint and the focus
	will remain on the constraints list widget, so that you can press the up / down arrows directly, for easier operation (suggested by Volker Dirr).
 5.27.6
	- Updated the sources to gcc-5.2.1 (but the Windows version still uses MinGW 4.9.2).
	- Minor improvements to the timetable and the statistics printing, by Volker Dirr (improved the margins handling).
 5.27.5
	- Minor improvements.
 5.27.4
	- Updated to Qt 5.5.0.
	- Added a new complete French translation, by Pascal Cohen.
	- Minor bug fixes: some buttons were not translated (reported by Pascal Cohen).
	- Added a new example file from Algeria, by Laid Messaoudi.
 5.27.3
	- Updated to Qt 5.4.2.
	- Added the "duration" filter in activities preferred starting times and preferred time slots (suggested by Volker Dirr and abdeljalil elghazoui).
 5.27.2
	- Fixed a compilation error under CentOS 6 (reported by azaer).
 5.27.1
	- Crash bug fix, when modifying a teacher after generating, and then viewing the timetable for that teacher without generating again.
	Reported by Yush Yuen.
	- Updated the German translation, by Bob Hairgrove.
 5.27.0
	- Writing the statistics of the generated timetable (gaps, min/max hours, free days), implemented by Volker Dirr.
	- Updated the Chinese Traditional translation, by James.
 5.26.2
	- Updated to Qt 5.4.1.
	- Crash bug fix when generating with zero students sets (introduced in FET-5.26.0).
	- Added a partial Chinese Traditional (zh_TW) translation, by James.
	- Updated the German translation, by Bob Hairgrove.
 5.26.1
	- Crash bug fix (probably never met, when using overlapping years) and improvements when removing students sets. Now you can completely remove a
	subgroup/group from a single button.
	- Added a test to report subgroups which have the same activities, so that the user can make generation faster by removing equivalent subgroups
	(if the user checks that the subgroups also have the same constraints).
	- Added a selectable option to show tool tips in the add/modify constraint dialogs which use tables (the tool tip is the day and the hour under
	the current cursor position). Suggested by Bob Hairgrove.
	- Updated the German translation, by Bob Hairgrove.
	- Code cleanup.
 5.26.0
	- FET is now licensed under the GNU Affero General Public License version 3 or later (suggested by Volker Dirr).
	- Improved the speed of importing from comma separated values (CSV) files, especially when dealing with many students sets.
	- Improved the speed of adding/modifying the (sub)activities from the corresponding dialogs (not noticeable, in usual cases).
	- Other speed improvements in the interface.
	- Leak and crash bug fixes (not usually met).
	- Some minor strings improvements.
	- Code cleanup.
 5.25.0
	- Improved the split year dialog: groups and subgroups which will exist in this year after the division will retain their activities and constraints.
	- Sort (temporarily) the constraints by description in the all time/space constraints dialogs. Also, removed the 'Sort by comments' button,
	which is probably useless.
	- Fixed a bug introduced in version 5.24.0: when having individually modified activities, removing teachers, subjects, activity tags,
	or students sets could remove only some components of the large split activity.
	- Some minor strings improvements.
 5.24.0
	- Updated to Qt 5.4.0.
	- Significant speed improvements when using many students sets (suggested by Volker Dirr).
	- Speed improvements in the statistics menu.
	- Other speed improvements for larger data.
	- Added an option to hide students subgroups in combo boxes/activity planning (useful if you have too many students subgroups
	and you don't use them in the interface).
	- Added options to select the categories of timetables to write on the hard disk.
	- Automatic division of years by categories is improved (suggested by alxgudea, Bobby Wise and Volker Dirr).
	- Code improvement in reading the .fet XML files: converted from the obsolete Qt classes QDom* to QXmlStreamReader. It brings
	speed and memory improvements when reading the input files, and ensures FET source compatibility with future Qt versions.
	Also error reporting when reading a corrupt file is improved. The structure of the .fet XML files is slightly changed,
	but of course older files are opened correctly.
	- Several bug fixes, when trying to open corrupt files.
	- Other bug fixes, reported by Vanyo Georgiev.
	- It is now allowed to have constraints preferred/home rooms with a single room (suggested by liquid and Volker Dirr).
	- Added a new example file from Vietnam, by nguyenhuuduyet.
	- Added a new example file from Namibia, by Bobby Wise.
	- Added two anonymous example files.
 5.23.4
	- Added a partial Chinese Simplified (zh_CN) translation, by orange.
	- Added two example files from Vietnam, by Nguyen Huu Tuyen.
 5.23.3
	- Updated to Qt 5.3.2.
	- Added a fet.desktop file (by Alexey Loginov).
	- Fixed some comments concerning the license (reported by Alexey Loginov).
	- Added a "make install" option (suggested by Alexey Loginov and other users, done by Zsolt Udvari and Liviu Lalescu).
	- Added an icon (suggested by Alexey Loginov and other users).
	- Added an option at compilation time so that FET automatically detects the system locale (suggested by Alexey Loginov and other users).
 5.23.2
	- Fixed a building problem under C++11 (reported by pkgsrc packager Thomas Klausner, solved by Jörg Sonnenberger).
 5.23.1
	- The teachers' timetables now show the list of teachers for team teaching; also the students' timetables now show the list
	of students sets for team teaching or show the students set of the activity if it is different from the currently selected
	students set (suggested and implemented by Volker Dirr).
 5.23.0
	- Updated to Qt 5.3.1.
	- Added a new timetabling generation option, to group selected activities in the initial order, next to the activity which is
	placed the earliest (suggested by Yush Yuen). This is useful in very rare cases of peculiar usage of constraint activities
	occupy max time slots from selection, or if you want to change the initial order of the activities by bringing some activities
	into front.
	- Improved the timetable shortcuts tab, by adding the print, locking and advanced push buttons.
 5.22.0
	- Updated to Qt 5.3.0.
	- Many improvements on memory and speed in pre-generating and after-generating.
	- Corrected a crash bug under Windows (for extremely large files).
	- Now you can unlock all activities or activities of a single day without generating the timetable (suggested by Volker Dirr).
	- Increased the maximum number of divisions in the first and second categories when dividing a year (suggested by Bobby Wise).
	- Added a new Morocco example file, by Mohamed Bahaj.
 5.21.3
	- Updated the Windows version to Qt 5.2.1.
 5.21.2
	- Corrected a bug in two of the Brazil examples (the bug was introduced in the previous version).
 5.21.1
	- Updated the sources to Qt 5.2.1 (but the precompiled Windows version still uses Qt 4.8.5, because of various problems).
	- Added an Albanian translation, by Artur Lugu.
	- Minor interface improvements.
 5.21.0
	- Updated the sources to Qt 5.2.0 (but the precompiled Windows version still uses Qt 4.8.5, because of various problems).
	- Added print of advanced statistics directly from FET, suggested by Bobby Wise and implemented by Volker Dirr.
	- Added an option to duplicate vertical names in the timetables, to the right of the tables (suggested by Pietro, implemented by Volker Dirr).
	- Updated the Brazilian Portuguese translation, by Cloves das Neves.
	- Added two example files from Brazil, by Werner Bruns.
	- Added another sample file from Argentina, by pedrobordon.
 5.20.2
	- Added an option to disable printing of the activity tags in the HTML generated timetables (suggested by drew and other users).
	- Memory consumption improvement when writing advanced statistics to the hard disk.
	- Dropped the debug console messages (potential bug reported by MarioMic), because under some GNU/Linux distributions
	these might fill the hard disk. However, the command line version can be made verbose by the option --verbose=true.
	- The multiple generation outputs an overall report (suggested by MarioMic).
	- Minor improvements and source cleanup.
 5.20.1
	- Minor improvements and bug fixes.
 5.20.0
	- Added constraint activities same room if consecutive (suggested by agemagician).
	- Added constraints students (set) max days per week (suggested by more users).
	- Bug fix in constraint activities occupy max different rooms (not noticeable).
	- Added a new sample file, by rapsy.
 5.19.4
	- Updated the sources to Qt 5.1.1 (but the precompiled Windows version still uses Qt 4.8.5, because of various problems).
	- Import bugs corrected (by Volker Dirr).
	- Added two new sample files, from Belize, by donjon.
	- Added two new sample files, from Algeria, by Laid Messaoudi.
 5.19.3
	- Corrected the Romanian translation (by Horatiu Halmajan, daviodan and Liviu Lalescu).
 5.19.2
	- Minor bugs corrected (formatting in the HTML timetables), by Volker Dirr.
	- Corrected some minor string problems.
	- Updated the Romanian translation (by Liviu Lalescu). It is now complete.
 5.19.1
	- Updated the sources to Qt 5.0.2 (but the precompiled Windows version still uses Qt 4.8.4, because of various problems).
	- Corrected some minor string problems.
	- Updated the Romanian translation (by Liviu Lalescu). Now it uses diacritics.
	- Updated the Ukrainian translation (by Andriy Melnyk).
	- Added a new sample file, by geaplanet.
 5.19.0
	- Updated the sources to Qt 5.0.0 (but the precompiled Windows version still uses Qt 4.8.4, because of various problems).
	- Made a separate command-line interface without using the X-screen (suggested by Danny Zitzman, Zsolt Udvari and maybe other users).
	- Made generation identical on all computers, by modifying QSet handling in the parts where the generation depends on the order of
	elements in a QSet (the elements are sorted and randomized, then). A minor bug was corrected with this occasion.
	- Now you can split a year into 4 categories (suggested by Bobby Wise).
	- When starting FET, the first shortcuts tab section (File) is selected (suggested by a user).
	- Added three new sample files, by waleed and Bobby Wise.
 5.18.2
	- Minor interface improvements.
	- Updated the French translation, by Regis Bouguin.
	- Added a new sample file, by Daniel.
 5.18.1
	- Minor code improvement.
	- Eliminated the MAX_SUBJECTS limitation (now there is a virtually unlimited number of subjects) - suggested by Volker Dirr.
	- Updated to Qt 4.8.2.
	- Added a new sample file (by L. W. Johnstone, from Belize).
 5.18.0
	- Very serious old bug fix. This was found trying to implement the new constraint (see below) in such a way to solve a more complicated file
	by Yush Yuen. Since nobody complained, it seems that until now the bug was not critical (but might have slowed down some timetables which have
	rooms and preferred/home rooms constraints). Bug exists from the start of the implementation of the space allocation in FET, probably.
	A big 'Thank you!' to Yush Yuen, who was very helpful in finding the problem.
	- Added a new constraint, activities occupy max different rooms (which can, for example, constrain some activities to be in the same room
	(in different time slots, of course) if max different rooms = 1). Suggested by Yush Yuen, nomad, Volker Dirr and maybe others.
	- Safe saving of .fet files (save with .fet.tmp name, then remove old .fet file, then rename .fet.tmp to .fet).
	- Saving of the random seed after the end of the generation (in addition to saving it at the beginning).
	- Added an Uzbek translation, by Orzubek Eraliyev.
 5.17.0
	- Printing of the timetables (directly from the interface), by Volker Dirr (suggested by Bobby Wise, Anwarul Alam, daviodan and maybe other users).
	- Updated to Qt 4.8.1.
	- Minor interface improvements and bug fixes.
	- Added a new Greek sample file, by Petros Nouvakis.
 5.16.1
	- Updated to Qt 4.8.0.
	- Bug fix: command line interface now accepts native file separator characters (reported by Sarwan Bangar).
	- When using command line with a time limit, and the time limit is exceeded, FET will save the highest stage and the current timetable.
	Suggestion and code by Ian Holden.
	- Exporting of the timetable as a CSV file now saves also the activities comments (suggested by m, implemented by Volker Dirr).
	- Minor bug fix in HTML timetables, by Volker Dirr.
	- Minor interface bug fixes.
 5.16.0
	- Each constraint can be activated/deactivated and also each constraint may have an optional comment. The user can sort the constraints
	based on their comment. These special functions can only be accessed from all time/space constraints dialogs (suggested by George Miliotis,
	Davide G. M. Salvetti and maybe other users).
	- Each activity may have an optional comment (suggested by K, m and maybe other users).
	- The command line version now saves the current timetable and the highest stage timetable if it receives SIGTERM from the user, then exits
	(suggested by Davide G. M. Salvetti and maybe other users).
	- Added a Vietnamese translation, by Nguyen Truong Thang.
	- Minor interface bug fixes.
	- Updated the Saudi Arabia examination timetable file, by Silver.
 5.15.0
	- Added two new constraints:
	1) Activities occupy max time slots from selection. This is useful in more cases, for instance to force
	some teachers to have activities in certain time slots. (For example, if in a 5 days week with 6 hours per day, teacher T has 20 hours of
	activities and needs to have activities in the first 3 hours of Monday: add a constraint with all the teacher's activities,
	all time slots minus these 3 (so 5*6-3=27 slots selected in the constraint), and specify the maximum number of selected time slots occupied
	by the selected activities to be 17.) Suggested by Zsolt Udvari, Christian Kemmer, Davide G. M. Salvetti, lalloso, Silver, and maybe other users.
	2) Activities max simultaneous in selected time slots. User chooses a set of activities, a set of time slots, and specifies
	that in each time slot there should be an upper limit on the activities from the chosen set. Useful for example if you want each slot
	to have say at least 3 free teachers, for substitution or supervision.
	- Updated to Qt 4.7.4.
	- Removed dependence of Qt3Support classes. Many dialogs were changed. This is to improve FET and to prepare it for the future Qt 5.
	- The program is now storing the geometry of most dialogs (suggested by more users. Zsolt Udvari suggested to store also the
	Activity planning dialog settings).
	- The activity tags, students, teachers, subjects, rooms, buildings, activities, subactivities, all time constraints
	and all space constraints dialogs contain a draggable splitter, for better viewing (suggested by daviodan).
	- Taking care of when a file was modified. When it was not modified, the user can quit FET directly (suggested by Horatiu Halmajan and maybe other users).
	- Recently used files list (suggested by daviodan, Silver and maybe other users).
	- Activities rooms statistics - it shows the list of activities which will certainly or possibly be scheduled in an unspecified room
	(suggested by Volker Dirr, who also did a part of the coding, Corfiot, Fabio Piedimonte).
	- Removed the upper limit on the number of time and space constraints.
	- When modifying the days or hours, the affected constraints will be modified or removed, after confirmation from the user.
	- Language change is activated without restarting.
	- Many other interface improvements.
	- Added a new sample file, by Silver.
	- Improved the Morocco sample file and the Morocco instructions (by Liviu Lalescu and Chafik Graiguer).
 5.14.5
	- Updated to Qt 4.7.3.
	- The generate multiple timetable dialog now shows max placed activities for the current timetable and for each timetable with time limit exceeded
	(suggested by Yush Yuen).
	- Non-critical interface bug fix under Mac OS X: in the add and modify activity dialogs, the tab widget for the subactivities was too large, showing
	all the 35 possible components. Bug reported by Yush Yuen.
	- Minor interface bug fix under Mac OS X: the dialogs now show minimize/maximize buttons. Bug reported by Yush Yuen.
	- Minor improvement in the HTML exported timetables (multi-line comments look better), by Volker Dirr.
	- Added a Galician translation, by Juan Marcos Filgueira Gomis (based on the Spanish translation, as of April 2011, by Jose Cesar Fernandez Lopez).
	- Added a Spanish secondary school example file, by llantones.
 5.15.0
 5.14.4
	- Upgraded to Qt 4.7.2.
	- Updated the French translation, by Regis Bouguin (it is now complete).
	- Added a complete Serbian translation, by Ivan Starchevicy and Radan Putnik.
	- Minor improvements.
	- Added 3 new sample files, by waleed, M K Lohumi and Asti Widayanti.
 5.14.3
	- Upgraded to Qt 4.7.0.
	- Improved the Greek translation, by Dimitris Kanatas.
	- Minor interface improvements.
	- Added two new sample files, by Massimo Mancini and Dimitris Kanatas.
 5.14.2
	- A rare possible problem is improved (not completely solved). This problem was reported by Marco Barsotti: for some fixed timetables the generation
	may report incorrectly an impossible timetable. This problem cannot be solved perfectly, only patched, and this will hopefully solve the problem
	in all practical situations.
	- An activity can now be split into 35 (it was previously only 10) - suggested by mohd on the forum.
	- Improved a bit the add/modify activity dialogs (inactive tabs for the components of a subactivity are disabled).
	- Updated the Slovak translation, by Ondrej Gregor.
	- Added a new sample file, by Marco Barsotti.
 5.14.1
	- Speed improvement in the generation algorithm (this speed improvement is better observable as the number of hours per week is larger).
	- Added a partial Hebrew translation, by Yotam Medini (only the main menu).
 5.14.0
	- Improved the random number generator, so that potential cycling problems are avoided (though probably nobody met such problems).
	The new random number generator has a much longer period and is better. The command line parameters for specifying the random
	seed are changed and you need to change your script if you use FET command line and if you want to specify the random seed.
	See the README file for the new command line parameters for specifying the random seed.
	- Improved memory consumption on constraints activity/activities/subactivities preferred starting times/preferred time slots.
	- Minor interface improvements.
	- Updates in the Arabic translation, by Silver.
 5.13.5
	- Corrected a bug, under newer versions of GNOME (the locked/unlocked icons for the special constraints were not shown in the menus).
	- Very rare bug fix (crash in import if some fields in a line are missing, reported by murad).
	- Other minor bug fixes in import (if an imported line was incorrect, the report message didn't specify this line number, in some cases).
	- Updated the Indonesian translation, by Nirwan Yus.
	- Updated the Spanish translation, by Jose Cesar Fernandez Lopez.
	- Code cleanup
 5.13.4
	- Added a Slovak translation, by Ondrej Gregor.
 5.13.3
	- Updated the Indonesian translation, by Nirwan Yus.
	- Rare minor bug fixed, reported by Frans on the forum.
	- Code cleanup.
 5.13.2
	- Increased max activities from 15,000 to 30,000 (suggested by murad). Also, increased max time constraints from 30,000 to 60,000 and max space constraints from 30,000 to 60,000.
	- Added a partial Sinhala translation (only the main menu), by Achini Duisna.
	- Updated the Indonesian translation, by Nirwan Yus.
	- Very rare crash bugs fixed.
	- Code cleanup.
 5.13.1
	- Corrected a generation bug (probably very rare, it gave impossible timetable). Bug may have appeared if using
	constraints students (set) early with max beginnings at second hour >= 1 and generating on a locked file.
	- Increased maximum number of teachers, subjects, rooms and buildings to 6000 (they were 3000 previously).
	- Corrected some HTML minor problems, by Volker Dirr.
	- Added a new sample file, by Chafik Graiguer (from Morocco). This user also describes tricks to use official FET for Moroccan schools.
 5.13.0
	- Updated to Qt 4.6.2.
	- For constraints students (set) min hours daily is now possible to allow empty days (in advanced usage) - suggested by Horatiu Halmajan and Catalin Maican.
	- Added a simple activity planning form, by Volker Dirr (see Advanced menu).
	- Now it is allowed to have 3 constraints of type interval max days per week for each students subgroup or teacher (it was maximum 2 previously).
	- Added export of active activities, by Volker Dirr.
	- Added Brazilian Portuguese translation (partial, incomplete yet), by Werner Bruns and Frank Martin.
	- Added Danish translation (partial, only the main form and a few other forms), by David Lamhauge.
	- Improved a bit the memory consumption.
	- The tables contain now an -x- (lowercase) if the teacher/students set/room is not available and -X- (uppercase) for a break (suggested by George Miliotis).
	Also, you can configure separately if you want breaks displayed and/or not available displayed.
	- Removed some useless messages, improving speed for some rare cases under GNU/Linux operating system and similar.
	- Added a few new sample files (by Christoph Schilling, Horatiu Halmajan and aliponte).
	- Changed default language/locale to en_US (instead of en_GB).
 5.12.3
	- Crash bug fix for a rare situation, in which you have constraints (sub)activities preferred starting times or time slots and they refer to no activity (reported by George Miliotis).
 5.12.2
	- Updated to Qt 4.6.1 .
	- Minor interface improvement: since a person reported he accidentally removed the basic constraints, it was added additional user confirmation for this, and more user information.
	- Corrected a possible compiling crash bug under MinGW (this is not a FET bug, it is a MinGW bug). It was made a hack to overpass this bug.
	- Improved export of timetable as CSV, by adding the id-s of the activities (suggested by m).
 5.12.1
	- Added Ukrainian translation (by Andriy Melnyk).
	- Bug fix: when modifying the number of students in a students set, the related activities will show the correct number of students, but the generation
	will consider the old number of students until the user saves and loads again the file.
	- Bug fix when adding/modifying a group's/subgroup's number of students, now all groups/subgroups with same name will have the same (new) number of students.
	- Improved speed of loading for large files and blocked user input while loading a larger file, because otherwise the user could obtain an incomplete file
	(minor bug reported by Volker Dirr).
	- Minor interface improvement: when exiting FET and choosing Save file, if you press Cancel, FET will not exit anymore - reported by Soyeb Aswat
	- Minor interface improvement: added a shortcut button to advanced functions in Time shortcuts section.
	- Minor leak fixed (when removing a group or subgroup).
	- Other minor bug fixes, when removing a group or a year.
 5.12.0
	- Added shortcut buttons on the main form (suggested by more users, especially: daviodan, Massimo Mancini, Paolo Cataldi). They can be deactivated from Settings - Interface menu.
	- Increased max activities to 15,000, max days per 'week' to 35, and other limits, and improved memory management. Now you don't need to have much virtual memory and memory usage is lower.
	This better memory management may bring a small slowdown of the generation, although in rare cases the new version may be faster. Speed variation depends also on the platform.
	More details about the possible slowdown: I compared times by starting parallel generations with the same random seed, which produces the same timetables in identical steps.
	I noticed usually less than 10% increased generating time, but in rare cases for some unusual files a bit more, maximum 17%.
	From the official examples, the worst situation is for the file Hungary/Bethlen/2007-2008-difficult/Bethlen_2007_2008.fet, with about 17% slowdown from FET version 5.11.0 to FET 5.12.0.
	I apologise for this "downgrade" of speed, but it is necessary.
	- Updated to Qt 4.6.0
	- Improved add activity dialog, by Volker Dirr: if in activities dialog, you select a filter and then try to add an activity, the values in this filter
	will be selected in the add activity dialog (this was also suggested by daviodan).
	- Minor interface improvements.
	- Changed help management (added links to online help).
	- Corrected/updated translations.
	- Code cleanup.
 5.11.0
	- Updated to Qt 4.5.2
	- Converted all dialogs to Qt 4 Designer files - suggested by George Miliotis.
	Compilation time is now shorter and intermediary and executable files are smaller.
	- Added constraint teacher(s) min days per week (suggested by several users).
	- Added constraint teacher(s) or students (set) activity tag maximum hours daily (suggested by several users).
	It is not perfect and must be enabled from settings menu.
	- Added constraint students (set) max gaps per day. It is not perfect and must be enabled from settings menu.
	- Very rare crash bug fix (reported by Marco Barsotti).
	- Constraint room not available times permits now multiple constraints for the same room (so, you can use multiple constraints with
	 different weights and preferences for the same room).
	- In add/modify activity and modify subactivity dialogs, the students are displayed in a tree-like structure (suggested by George Miliotis).
	- In all constraints dialogs, added a nice filter (suggested by daviodan).
	- Changed name of constraint: MinNDaysBetweenActivities becomes MinDaysBetweenActivities.
	- Added a count for activities list and constraints list.
	- The constraints with tables now contain an X (nicer look), also centered nicely, and they have colors (which can be enabled in settings)
	- The timetables view forms now center text in cells.
	- Many other minor interface improvements.
	- Rewritten the Catalan translation by Silvia. It is very complete, check it out.
	- Added a new Greek sample file, by George Miliotis.
	- Updated and improved Persian translation by sally sat.
	- Dropped !DOCTYPE FET tag in the .fet files - following general recommendations, and changed FET tag to fet tag. Of course you can open older files.
	- Improved activities simple description (suggested by Massimo Mancini and Chafik Graiguer).
	- Added possibility to save the highest stage timetable (suggested by Chafik Graiguer, pinco and Massimo Mancini).
	- Added a new Romanian sample file, by Horatiu Halmajan.
	- Updated translations: Russian, German, Romanian, Italian, Spanish.
	- The timetable view dialogs now have resizeable widgets (you can drag the sections with the mouse) - suggested by Ben Bauer.
 5.10.3
	- Added 2 new constraints: three activities grouped, max days between activities (suggested by Zsolt Udvari).
	- Improved the names of constraints: "2" activities grouped, ordered and consecutive are now "two" activities grouped, ordered and consecutive.
	- Code cleanup.
	- Added a new Italian sample file, by Marco.
 5.10.2
	- Speed improvement if user has constraints activities same starting time, 2 activities consecutive and 2 activities ordered and
	 activities not overlapping (idea and partial code by Volker Dirr). In some cases, the speed improvement is very high. This has to
	 do with the initial ordering of the activities.
	- Other minor speed improvements (idea and partial code by Volker Dirr).
	- Added a Persian manual by Hamed SadeghiNeshat.
 5.10.1
	- Speed improvement if user has constraints activities same starting time. Idea and partial code by Volker Dirr.
	- Added possibility to print activities with same starting time in the html timetables (suggested on the forum, implemented by Volker Dirr).
	- Minor interface improments under GNU/Linux. The combo boxes are now smaller.
	- Modified the main menu arrangement of constraints (suggested by Massimo Mancini).
	- Crash bug fix (very rare, if user pressed cancel immediately after hitting generation start in timetable generate dialog).
	- Added another sample file (by T. Renganathan).
 5.10.0
	- Leaking bugs fixed (closed Qt widgets were not removed).
	- Bug fix in generation algorithm. This bug is not seen in practice, but the code in generate.cpp was incorrect in a minor portion.
	Specifically, it corrected tests done when the user has constraints of type students early max beginnings at second hour,
	without max gaps per week for students, with max or min hours daily for students.
	- Added constraint teachers max days per week (suggested by Marco Barsotti).
	- Made the results directory customizable (user can choose it) - suggested by Massimo Mancini.
	- Fixed a bug: if user deactivated some activities, in some cases he could not generate a timetable (if using preferred times
	for (sub)activities).
	- Added a filter in add and modify dialogs constraints activities not overlapping (suggested by Yush Yuen).
	- Added a new feature in the timetable generate dialog, which allows you to see the time when the highest
	number of activities was placed (suggested by Yush Yuen).
	- Added a Catalan translation of the manual, by Joan de Gracia.
	- Changed the name of the html timetable files.
	- Corrected many translations' layout (by Liviu Lalescu).
	- Added a new test for inconsitency for indirect links between constraints actvities same starting time
	(suggested by Silvia).
	- Minor improvement - in students statistics menu, user can select to view complete structure (duplicates enabled)
	or canonical structure.
	- Interface improvement - dialogs when removing the constraints or adding them are improved, so that they are not
	very large for large constraints.
	- Selection mode in constraints not available and preferred slots is improved - you can click table header
	(suggested by Massimo Mancini).
	- Minor other interface improvements.
	- Export warns if existing files (suggested by Angela).
	- Changed directory of sample inputs to 'examples'.
	- Added a 'Related' checkbox in activities and subactivities dialogs (suggested by Bingen).
	- Speed improvement in some precomputing situations (not in generation).
	- Improved size for constraints with combo boxes of very large activities (suggested by Bingen).
 5.9.4
	- Added the Russian translation (incomplete) - by Ilya V. Paramonov
	- Added the Persian translation (incomplete) - by Hamed SadeghiNeshat
	- Minor bug fix by Volker Dirr - highlighting the same teacher or student set, for html level >= 5, did not work
	correctly for advanced statistics export.
	- Improved compilation time and memory consumption by modifying the data reading and parsing routines
	(additional checking/tests needed here).
	- Minor memory leak fix (normally, not noticeable).
	- Minor interface bug fix (description of constraint teacher max gaps per day displayed incorrectly information about the
	gaps, writing "per week" instead of "per day").
	- Modified the order of search for translation files (firstly in current directory, then in current directory/translations,
	then, under systems which support it, in /usr/share/fet/translations).
 5.9.3
	- Added constraint activity tag preferred room(s) - suggested by Horatiu Halmajan and Catalin Maican
 5.9.2
	- Crash bug fix when importing activities (reported by Thomas Schwartz).
	- Improvements and corrections in the import filter.
 5.9.1
	- Improved a situation for fixed timetables which were impossible sometimes (reported by Horatiu Halmajan). This bug is
	not entirely fixed.
	- Improved the html timetables by Volker Dirr.
	- Crash bug fix for constraint min gaps between activities with weight below 100%.
	- Bug fix in students early constraint - not critical bug.
	- Updates in Arabic translation.
 5.9.0
	- Added multiple activity tags for a single activity.
	- It is now possible to edit a single subactivity.
	- Added constraints teacher(s) or students (set) activity tag max hours continuously (to specify that
	a teacher or a students set must have maximum n hours continuously for an activity tag) - suggested by Silver,
	George Miliotis and Volker Dirr.
	- Improved a bit the memory consumption.
	- To avoid problems with very large filenames, the sample file names were shortened.
	- Minor html timetables corrections (cosmetic).
	- Updates in Spanish, Arabic, Romanian and Italian translations.
	- Minor improvements.
 5.8.1
	- Minor improvements (code cleanup) - modified a bit the xml files to contain for boolean variables only true/false values
	instead of yes/no (following xml format recommendations).
	- Minor improvement: the constraint activity preferred starting time must have now the day and the hour both specified,
	so there is a clearer distinction between preferred starting time and preferred starting times.
	- Minor improvement - when reading some kind of invalid data, instead of crashing, now FET reports the error
	(like for instance duplicate teachers, or subjects, or wrong tags).
	- Minor improvements in the Italian, Arabic and Spanish translations.
	- Added a sample file from Azu Boba.
	- The index.html links now open in the same window (suggested by daviodan).
 5.8.0
	- Added the possibility to view locked activities in the timetables and toggle lock/unlock activities in the timetable
	(suggested by Azu Boba, implemented by Liviu Lalescu and Volker Dirr).
	- Added the possibility to lock/unlock the activities of a certain day
	(suggested by Azu Boba, implemented by Liviu Lalescu and Volker Dirr).
	- Added the possibility to lock/unlock the activities which end students day
	(suggested by Volker Dirr, implemented by Liviu Lalescu).
	- The constraints activity preferred starting time and activity preferred room have now an attribute, which
	can mean that some constraints are added permanently by the human operator and cannot be unlocked from the view timetable
	form (suggested by Azu Boba, done by Liviu Lalescu and Volker Dirr).
	- Minor bug fixes (very rare crashes).
	- Minor improvements - when viewing the timetable, the detailed activity view is updated correctly
	(suggested by Jose Cesar Fernandez Lopez).
	- Other minor interface improvements.
	- Minor improvements.
	- Repaired the Turkish translation (by Liviu Lalescu), but it is still old and incomplete.
	- Added the output of activities timetable as xml
 5.7.7
	- Minor improvements (the settings are now saved in a file which does not contain spaces under GNU/Linux,
	other improvements).
 5.7.6
	- Minor interface improvements
	(Command line version now has the parameter "htmllevel", the old one was
	"timetablehtmllevel", which still works. Added description in the README file of the default values.
	Other interface improvements).
 5.7.5
	- Added constraint 2 activities grouped, which is the non-oriented version of constraint 2 activities consecutive
	(the activities can be placed in any order, but one near the other) (suggested by sherman)
	- Added an additional test to ensure that constraints same starting time are not impossible
	- Very minor bug fixes (when working with redundant constraints same starting time/day/hour). This bug
	is most probably unnoticed.
	- Added an additional sample file by Zsolt Udvari (Bethlen, Hungary).
 5.7.4
	- Minor bug fix - if searching for updates at startup is enabled, it gave segmentation fault when exiting FET, under GNU/Linux.
	Probably unnoticed bug.
	- Switched to Qt 4.4.3
	- Added a user's manual by Volker Dirr
	- Spanish translation update by Jose Cesar Fernandez Lopez
	- Added an additional sample file by Horatiu Halmajan (Faculty of Economics, Timisoara, Romania)
 5.7.3
	- Modified a bit the spreading activities dialog, now the activities split into 2 and 3 not in consecutive days
	is by default NOT checked, because this might lead to impossible timetables for difficult files. If you want
	spreading for these activities, you need to manually select this option.
	- Arabic translation update by Silver
 5.7.2
	- Added 2 more samples by Cristian Balint
	- Small bug fix in statistics exported as html, by Volker Dirr
 5.7.1
	- Added an option to remove redundant constraints
	- Added exporting of advanced statistics as html by Volker Dirr
	- Arabic translation update
 5.7.0
	- Added an advanced command to spread better the divided activities in a week - very useful for schools, probably.
	- Minor interface improvement (in report duplicate activities routine)
	- Added status bar for File -> new, open, save and save as menus
 5.6.4
	- Improved Arabic, Lithuanian and Italian translations.
	- Improved a very very rare situation (raised the maximum number of retries for a single activity from 100,000 to 200,000.
	This way, some saved timetables which contain constraints with weights close to 100% and below 100% (like 99.995%) are possible.
	Probably this situation is unnoticed by anybody). The possible problem is not perfectly solved, but it is a compromise.
	- Added possibility to mark or not -x- in the not available slots in timetables (suggested by Silvia, done by Volker Dirr).
	- Added all activities timetables by Volker Dirr (suggested by kdsayang)
	- Added exporting of timetable in csv form by Volker Dirr
 5.6.3
	- Crash bug fix (probably rare)
	- Added an -x- in the not available slots in teachers', students' and rooms' timetables
	(suggested by George Miliotis), added by Volker Dirr.
	- Added Lithuanian translation by Darius Staigys (incomplete yet).
 5.6.2
	- Added constraint teacher(s) and students (set) interval max days per week, to specify an hourly interval
	and the maximum number of days per week for teachers (students) to work in this interval (suggested by Silver).
	This constraint is very useful, for instance specify that teachers and students must not work more than 2
	times per week in the last hour of the day.
	- Added constraint a set of activities end students day - to specify for a group of activities that they
	should end the day for students (for instance for meetings with the class master) - suggested by Zsolt Udvari.
	- Bug fix - when modifying a constraints (sub)activities preferred starting times or time slots, the activity tag
	is now correctly updated.
 5.6.1
	- Crash bug fix (probably very rare).
	- Added possibility to change easier more constraints min n days between activities
	- Added constraints subactivities preferred time slots and subactivities preferred starting times
	(suggested by Volker Dirr). You can specify the component number for subactivities, useful for constraining courses,
	say only the first or the last components of a split activity to be placed earlier.
	- Switched to Qt 4.4.0 and gcc 4.3.1
	- Indonesian, Romanian, Italian, German translations updates.
 5.6.0
	- Added import/export CSV (text with comma separated values) filters by Volker Dirr.
	- Added constraint min gaps between activities (suggested by several users).
	- Add activity dialog, checking/unchecking show years/groups/subgroups does not erase inserted sets (suggested by Zsolt Udvari).
	- Small bug fix when importing activities, consecutive if same day is not correctly imported (reported by daviodan).
	- Added Romanian help for export/import by daviodan.
 5.5.9
	- Added constraint activity(ies) preferred STARTING times, the old preferred times constraints are renamed preferred time slots
	and are more correct now, taking into consideration the duration of each activity (reported by Volker Dirr).
	- Allowing more constraint activity preferred starting times (or preferred time slots) for same activity id,
	which was restricted by a bug to only one. You can add more constraints with different weights.
 5.5.8
	- Bug fix - when saving a timetable, regenerating it might give an impossible timetable - reported by Yush Yuen.
	This bug solved other possible important bug (I doubt someone observed this bug. What happens: if an
	activity has a fixed time, then when FET allocates it it fixes a room for this activity and consequent
	changes are not possible to reschedule this activity to another room - might give impossible timetable in extreme cases).
	Now it is possible to reallocate the room to another slot.
	- Improved add activity dialog - if min days is x (greater than 1) and weight is lower than 100.0%, user can add
	a second constraint with x-1 min days, to ensure activities are better separated.
	- Added advice to remove redundant min n days constraints when adding same starting time constraints.
	- Added another sample by Yush Yuen.
 5.5.7
	- Added 2 samples from Namibia (by Bobby Wise).
	- Added 1 sample from Namibia (by Willy Henckert).
	- Arabic and Greek translations updates.
	- Bug fix - now inactivating some activities allows to generate the timetable, because constraints referring to
	these activities are ignored (suggested by Yush Yuen).
	- Improvement - activating/deactivating activities for a year/group considers also the activities of included groups/subgroups
	(suggested by Yush Yuen).
 5.5.6
	- Arabic, Romanian, Spanish, Italian translations update.
	- Added an option to select all slots available or not available for constraints break, not available and preferred times
	(suggested by didit).
	- Added another Arabic sample by Silver
 5.5.5
	- Very small bug fix (very unlikely to happen, also the effect is almost null)
	- Indonesian, Spanish and Arabic translation updates
	- Added an additional check for inconsistency
 5.5.4
	- Greek, Romanian, Spanish translations updates
	- Small interface improvements
	- Added constraint 2 activities ordered, to allow to say: activity A2 must be after A1, separated
	by any number of days or hours (suggested by kdsayang)
	- Added constraint teacher(s) max hours continuously (suggested by kdsayang)
	- Added constraint students (set) max hours continuously (suggested by kdsayang)
	- When modifying a constraint min n days between activities, it checks for duplicates (suggested by kdsayang)
	- Crash bug fix (rare, if using home rooms with weight under 100% and rooms are constrained)
	- Added more tests to ensure home rooms inputted correctly
	- Generating multiple now saves each timetable in .fet form (suggested by kdsayang)
	- Increased number of days per week to 28, to allow exam scheduling (suggested by kdsayang)
 5.5.3
	- Crash bug fix - when adding a year with same name as a group or subgroup (reported by Volker Dirr)
	- Small interface improvements
	- Added checks to ensure that duplicate students sets are reported (suggested by Volker Dirr)
 5.5.2
	- Small improvements in the interface.
	- Updated German and Indonesian translation.
	- Possibility to save current timetable in .fet form, with activities locked on their places
	(suggested by Horatiu Halmajan)
 5.5.1
	- Improved handling of multiple constraints preferred room for same activity (or same
	subject or same subject+activity tag) - suggested by Volker Dirr.
	- Improved Romanian translation.
	- Small improvements in the interface.
 5.5.0
	- Modified the algorithm (better or (hopefully not) worse)
	- Command line FET
	- Constraint teacher(s) max gaps per day
	- Constraint students (set) max gaps per week
	- Constraint students (set) early max beginnings at second hour
	- Subject tags are now named correctly activity tags
	- Constraints students set/teacher home room(s)
	- Buildings, building changes constraints
	- Constraint activities same starting day
	- Teachers, students sets, rooms, breaks not available matrices
	- Updated Romanian, Greek, Italian, Arabic translations by the persons in charge
 5.4.18
	- Small code cleanup
	- Italian instructions and FAQ by Marco Barsotti
	- Greek translation update by my80s
	- When opening a corrupt file, it reports line, column and error.
	- Added an Italian sample by Marco Barsotti.
	- Made possible to lock not only time, but also space or both when viewing the timetable
	(suggested by Horatiu Halmajan)
	- Small improvement: maximum room capacity and number of students for a set is now 15000,
	instead of 1000
	- Teachers free periods timetable by Volker Dirr
 5.4.17
	- Faster precomputation
	- Significant speed improvement in saving html timetables by Liviu Lalescu
	- Subjects timetables - by Volker Dirr
	- Increased max students sets to 15000.
	- Faster statistics for students.
	- More allowed subgroups and teachers per activity.
	- Added more redundant tests to check final solution to respect no gaps, early, max gaps, min hours daily
	- Faster precalculation
 5.4.16
	- Groups and years timetables contain dashed lines in cells which contain more activities
	(suggested by Silver, done by Volker Dirr)
	- Arabic translation update by Silver
 5.4.15
	- Added an Arabic sample file by Silver
	- Various translations updates
	- Update of README file
	- MAX_ACTIVITIES is now 5000
 5.4.14
	- Minor interface improvement - in add rooms dialog, pressing Enter now works better, it adds a room,
	not displays Help
 5.4.13
	- Small bug fixes in html generated timetable by Volker Dirr
	- Indonesian translation by Nirwan Yus
	- Italian translation by Marco Barsotti
	- Arabic translation update by Silver
 5.4.12
	- Greek translation update by Dimitrios Ropokis
	- Arabic better support
	- Arabic translation update by Silver
	- Code cleanup
	- Switched to Qt 4.3.2
 5.4.11
	- Arabic translation (partial), by Silver
	- Small bug fixes in export to html by Volker Dirr
 5.4.10
	- Improvement in generation, now retrying 100,000 times before giving up for a specific activity,
	works even if activity has preferred times with high weight on impossible slots
	(the idea is that if you have constraints activity(ies) preferred times for impossible
	slots with weight under 100%, you will get eventually a timetable which contradicts these constraints
	and is viable). This can be considered important bug fix
	- Greek translation by Dimitrios Ropokis
 5.4.9
	- Spanish instructions by Jose Cesar Fernandez Lopez
	- Groups and years timetable by Volker Dirr (in addition to old subgroups timetable)
	- Small interface improvements (added filters in dialog of constraints: activity preferred time(s),
	min n days between activities, activity preferred room(s))
 5.4.8
	- Minor cosmetic changes
 5.4.7
	- Minor cosmetic changes
 5.4.6
	- Minor cosmetic changes
	- Improvements in Spanish translation by Jose Cesar Fernandez Lopez
 5.4.5
	- Minor cosmetic changes
 5.4.4
	- It is allowed now to save the file name containing parentheses (), quotation marks " are not allowed anymore,
	and neither is semicolon ; because the html code does not work correctly
 5.4.3
	- Larger values for maximum number of years, groups and subgroups (suggested by Volker Dirr)
	- The split activities are now indented, for easier visualization
	- Improved add constraint activity preferred room(s) dialogs, by adding filters
 5.4.2
	- Main form interface improvements
	- Updates in Romanian, German and Spanish translations
	- Corrected crash bug when disk is full - reported by Maciej Deorowicz
	- Added detailed activity description in activity preferred room(s) constraints
	- Bug fix - when removing a room, related constraints subject subject tag preferred rooms
	are updated correspondingly (unlikely to happen bug)
 5.4.1
	- Improvement in Spanish translation by Jose Cesar Fernandez Lopez
	- The min hours per day for teachers works even when a teacher has 0 hours in a week
 5.4.0
	- Improvement in Spanish translation by Jose Cesar Fernandez Lopez
	- Now the max hours daily for teachers and students has any weight percentage allowed, again
	(suggested by Dimitrios Ropokis), allowing also combinations (not really any combination, but nobody needs
	more than what is possible in FET, I think)
	- Additional checking the min n days for impossible situations
	- Constraint teacher(s) min hours daily, suggested by Daniel Chiriac
	- Crash bug fix when using teachers max gaps for only some of the teachers (reported by Volker Dirr)
 5.3.6
	- Small changes in add/modify activity dialog
	- Small changes in Settings menu
	- Added timetable html level by Volker Dirr (you can select a level from 0 to 5,
	each with additional options, where level 5 has for instance highlighting of similar
	fields when moving mouse over text)
	- Added additional tests to check for impossible constraint min n days between activities
	- Added possibility to change all min n days constraints' weight by a single command
 5.3.5
	- Added additional tests to see if max hours daily for teachers/students can be respected
	- Added additional test to see if max days per week for teachers and teacher not available
	are not impossible
 5.3.4
	- Spanish translation by Jose Cesar Fernandez Lopez
 5.3.3
	- Important potential bug fix, when using students max hours daily without no gaps, with breaks
	- Small improvements, bug fixes
	- Constraint activity ends students day
 5.3.2
	- Small improvement in help
 5.3.1
	- Bug fixes in max hours per day
 5.3.0
	- Improved constraint students (set) max hours daily (important speed bug fix)
	- Constraint students (set) or teacher max hours daily has now compulsory 100% weight
 5.2.19
	- Added information to avoid min hours daily situation when students have a day off, help by Volker Dirr
 5.2.18
	- Crash bug fix relating constraint students (set) min hours daily combined with not available or break
	(reported by moryus)
	- Verious improvements
 5.2.17
	- The teacher max days per week is necessary 100% now
 5.2.16
	- Minor improvements
 5.2.15
	- The default/maximum time limit for multiple timetables is 1200 minutes (a large enough value)
	- Minor improvements
 5.2.14
	- Interface improvements
 5.2.13
	- Modified the divide year dialog, to allow 12 divisions for the first category
	- Bug fixes (when using activities with no teachers or no students, removing a teacher
	or a students set might remove accidentaly such activities) - corrected
	- Added more information about dividing a year
 5.2.12
	- Very small interface improvements
 5.2.11
	- Small potential bug fixes - when reducing the number of hours or days, the old constraints
	referring to old variables now are reported as wrong
	- Small bug fix - crashed if user removed directory "results" while program was running
 5.2.10
	- Small improvements in interface
	- The teachers max gaps can have now only 100% weight
	- Improvements in Romanian translation
 5.2.9
	- Small improvements in interface
 5.2.8
	- Added a test to see if teachers or students have enough slots, from not available constraints
	- Small bug fixes
 5.2.7
	- Interface improvement
	- Small bug fix (when modifying hours or days)
	- Crash bugs fixed - reported by mantas
 5.2.6
	- Minor interface improvements (the conflicts are now named soft conflicts, as they should)
	- Small speed improvement, by changing the timetable generate dialog
 5.2.5
	- Small instructions improvements
 5.2.4
	- Small interface improvement (now the add activity dialog has default show subgroups unchecked)
 5.2.3
	- Small bug fix - when clicking cancel on exit, the filename is preserved correctly
	- Small corrections
 5.2.2
	- Small bug fix (when aborting generation or generation is impossible, correct conflicts are
	written on hard disk)
 5.2.1
	- Bug fix in conflicts reporting in conflicts.txt for single timetable generation
 5.2.0
	- Various small improvements
	- Multiple timetables generation (suggested by Volker Dirr)
	- Constraint 2 activities consecutive (suggested by Felix FSH)
 5.1.12
	- Changes in automatic generation (I hope improvements)
	- Constraint subject subject tag preferred room(s) (suggested by Volker Dirr)
 5.1.11
	- Improvements in automatic generation
	- Improved saving of x-html timetables by Volker Dirr
 5.1.10
	- Detailed constraint activity ... (min n days, preferred time(s), same starting time,
	same starting hour, not overlapping) now contain the teacher, subj, subj tag and students)
	(suggested by Volker Dirr).
	- Better initial sorting - better automatic generation
 5.1.9
	- Better initial sorting -> better automatic generation
 5.1.8
	- Update in German translation by Volker Dirr
	- Improvement: if activity contains duplicated subgroups, this is not reported to the user anymore
	(suggested by Volker Dirr)
	- Improvement in rooms allocation - if room free, activity is placed, even
	if constraint subj (act) pref room(s) has low weight (suggested by Volker Dirr)
	- Changes in automatic generation (I hope good ones)
	- Improvement in adding constraint activities same starting time (filter change does
	not remove activities any longer) (suggested by Volker Dirr)
	- Improvement in adding constraint min n days between activities (filter) (suggested by
	Volker Dirr)
 5.1.7
	- I hope improvements in automatic generation
 5.1.6
	- Students not available does not induce gaps or early unrespected
	- Teachers not available does not induce gaps
	- Improvement in automatic generation (cycles avoided better)
 5.1.5
	- Improvements in interface (double click in Teachers, Subjects, etc. now modifies).
	- German translation update by Volker Dirr.
 5.1.4
	- Improvements in dividing year (suggested by Constantin Romulus and Volker Dirr).
	- Improvements in Romanian translation.
	- Improvements in German translation by Volker Dirr.
	- Small improvements in interface.
	- The user can now double click in any constraints dialog to modify.
 5.1.3
	- Improvements in dividing year (suggested by Volker Dirr and Constantin Romulus).
 5.1.2
	- Allow only one category for splitting a year.
 5.1.1
	- Bug fixes (students sets).
	- Division of years automatically (suggested by more users).
 5.1.0
	- Minor cosmetic changes in code by Volker Dirr.
	- Constraint students (set) min hours daily (suggested by Zsolt Udvari).
	- Improved automatic generation.
 5.0.2
	- Potential (very unlikely) bug fix in random.
	- Changes in automatic generation (hope good changes).
	- Small interface changes.
	- Improvements in translation by Volker Dirr.
 5.0.1
	- Improvement in generation.
	- Weights can now be real numbers.
	- Random generator improved (from Knuth).
 5.0.0
	- Can have activities with no teacher or no students set (suggested by Volker Dirr).
	- Rooms and space allocation.
	- Improved the automatic generation.
	- Bug fix in generation (faster now on newer processors?).
	- Speed improvement in generation.
	- Improved algorithm in minimizing broken constraints min n days between activities.
	- Bug fix in constraint activities preferred times.
 5.0.0-preview30
	- Improvements in optimization algorithm.
 5.0.0-preview29
	- Geometry of main form now saved correctly (suggested by Volker Dirr).
 5.0.0-preview28
	- Small changes in saving the xhtml timetables on disk, by Volker Dirr
	- Improved the algorithm (maybe speed improvements)
 5.0.0-preview27
	- Possible improvement in the optimization algorithm
	- Improved saving the xhtml of timetable by Volker Dirr
	- Small bug fix
 5.0.0-preview26
	- Improved documentation.
 5.0.0-preview25
	- Improvement in the optimization algorithm.
	- Possible bugs fixes (unlikely to happen bugs).
	- Improved Romanian translation.
 5.0.0-preview24
	- Bug fix in saving ConstraintTeacherMaxHoursDaily
 5.0.0-preview23
 5.0.0-preview22
	- Bug fix when a single activity cannot be scheduled
	- The break is not counted as a gap for teachers and students
	- Improvement in optimization, for early and gaps - speed improvement in optimization
	- Check for updates on startup
 5.0.0-preview21
	- Bugs fixed (not observable usually)
	- Modified adj if broken to be consecutive if same day for min n days constraint
 5.0.0-preview20
 5.0.0-preview19
	- Improments in Romanian translation by Liviu Lalescu.
	- Small improvements in interface.
 5.0.0-preview18
	- Very small improvements.
 5.0.0-preview17
	- Improvements in add/modify activity dialogs (suggested by Constantin Romulus)
	- Improvements in add/modify constraints not overlapping, same starting hour/time,
	min n days between activities (suggested by Constantin Romulus).
	- Bug fix - when pressing Esc in the allocation of hours.
 5.0.0-preview16
	- Crash bug fix in teacher max days per week (reported by Constantin Romulus)
 5.0.0-preview15
	- Romanian language update by Constantin Romulus and Liviu Lalescu
	- Improved html timetables (suggested by L. W. Johnstone)
 5.0.0-preview14
	- Romanian language update by Constantin Romulus
	- Teacher(s) max hours daily (suggested by Constantin Romulus)
	- Students (set) max hours daily (suggested by Constantin Romulus)
 5.0.0-preview13
	- Students set early (suggested by Constantin Romulus)
	- Cannot allocate now without basic time constraints (no more crashing otherwise)
	(reported by Constantin Romulus)
 5.0.0-preview12
	- Crash bug fix
 5.0.0-preview11
	- Improved the algorithm
	- Fixed bug for constraint teachers max gaps per week
 5.0.0-preview10
 5.0.0-preview9
	- Raised the limits of max number of activities, constraints,
	max activities for each constraint activities not overlapping and others
	- Improved the solving of activities not overlapping
 5.0.0-preview8
	- Made possible again ConstraintActivitiesNotOverlapping
 5.0.0-preview7
	- Bug fix in ConstraintBreak
 5.0.0-preview6
	- Improvements in the optimization - optimizetime.cpp
 5.0.0-preview5
	- Improvement in the optimization - optimizetime.cpp
 5.0.0-preview4
	- The students gaps now are measured in hours (a 2 hour gap means 2 conflicts,
	not just one as before).
	- Improved saving xhtml timetables by Volker Dirr
	- Removed the preferred time when adding an activity (useless)
	- Removed not important time constraints which do not fit into new algorithm
 5.0.0-preview3
	- Added a warning that older files will be converted as follows: min n days
	will have weight percentage 95% and adj if broken=true
 5.0.0-preview2
	- Added activities same starting time & hour constraints into time optimization
 5.0.0-preview1
	- new algorithm
	- too many changes to mention
 4.2.9
	- Small bug fix (reported by Volker Dirr).
	- Bug fix - students n hours daily (observed by Liviu Lalescu).
	- Liviu Lalescu,
	- xhtml form of saving timetables by Volker Dirr (timetabling.de)
 4.2.8
	- Added Macedonian translation (by Zoran Zdravkovski).
 4.2.7
	- Added Hungarian translation (incomplete), by Ferenczi Viktor.
	- Output files (besides the .fet data file) now handle correctly special
	local characters (suggested by Zoran Zdravkovski).
	-Add and modify activity dialog now report correctly the current name,
	including local characters (reported by Zoran Zdravkovski).
 4.2.6
	- Small interface improvements, the modify constraint activity preferred time
	and modify constraint activity preferred times contains a filter (suggested
	by Abdul Hadi Kamel)
 4.2.5
	- Small interface improvements, the add constraint activity preferred time
	and add constraint activity preferred times contains a filter (suggested
	by Abdul Hadi Kamel)
 4.2.4
	- French translation improved by Patrick Fox.
 4.2.3
 4.2.2
	- The statistics dialogs show only active activities (suggested by Volker Dirr)
	- Turkish translation update by Mahir Nacar
 4.2.1
	- Bug fix - when renaming a students set which is contained in some activities
	(reported by Viktor Ferenczi)
 4.2.0
	- Implemented 2-point and uniform crossover, by Mr. Volker Dirr.
	The default crossover method is 2-point, which should give better results
	than the 1-point crossover.
	- Added ConstraintTeachersMinHoursDaily (suggested by Manolo Par).
 4.1.10
	- Possible bug fix (reported by Volker Dirr).
	- Liviu Lalescu,
	- 2-point and uniform crossover implemented and tested by Volker Dirr
	- Turkish language update by Mahir Nacar
	- French translation update by Patrick Fox
	- Macedonian translation by Zoran Zdravkovski
 4.1.9
	- Possible small bug fix (reported by Volker Dirr).
 4.1.8
	- Improved readability and corrected possible future bugs, by adding a
	chromosome property called "timeChangedForMatrixCalculation" and
	"spaceChangedForMatrixCalculation" (suggested by Volker Dirr).
	- The minimum population size in the dialog is now 3
	(suggested by Volker Dirr).
 4.1.7
	- The default population size is now MAX_POPULATION_SIZE
	instead of 8192 (suggested by Volker Dirr).
	- Added a description on how to compile/run FET on Max OS X (by Gabi Danon).
	- Bug fix, when erasing a year, group or subgroup (reported by Volker Dirr).
	This bug was introduced in version 4.1.6.
 4.1.6
	- The number of students can now be set for a particular activity
	(suggested by Abdul Hadi Kamel)
	- Bug fix - when removing or modifying the students sets for an
	activity, the number of students for that activity are modified
	accordingly.
	- Small bug fixes
 4.1.5
	- Bug fix - trying to add duplicate constraint activity preferred time
	reports now a duplicate instead of "please report error" (reported
	by Volker Dirr).
	- FAQ improvement by Les Richardson.
 4.1.4
	- Improved dialogs constraint activity preferred time and constraint
	activity preferred times, by adding a description next to the
	activity id (suggested by Volker Dirr).
	- Corrected a small bug in ConstraintStudentsSetIntervalMaxDaysPerWeek
	(in reporting conflicts, the subgroup was not correct).
	- Added ConstraintTeacherIntervalMaxDaysPerWeek (suggested by
	Daan Huntjens).
 4.1.3
	- The constraint activity preferred times and constraint activities
	preferred times add and modify dialog are improved (suggested by Volker Dirr).
 4.1.2
	- The windows are now centered about the screen.
	- Removed unused "pause" buttons in allocation menus.
 4.1.1
	- In the Modify Activity Dialog, the "split into..." spin box is now shaded,
	to show that the modification of it is impossible (suggested by Volker Dirr).
	- The default value for "minimum required distance in days between sub-activities"
	in the add activity dialog is now 1 (suggested by Volker Dirr).
	- The main window title now contains the name of the file (suggested by Volker Dirr).
	- The add and modify activity dialogs are improved (suggested by Volker Dirr).
	- Now the windows contain maximize/minimize buttons (suggested by Volker Dirr).
	- Added teachers, subjects and students statistics (suggested by Volker Dirr).
 4.1.0
	- In the Modify Activity Dialog, the "split into..." spin box is now showed correctly
	- Added German translation (by Volker Dirr)
	- Improved viewing the timetable dialogs (suggested by Volker Dirr). Now the table
	column and row description contain the name of the hours and days.
 4.0.9
	- Bug fix - when dealing only with one year or group, the results are now
	displayed correctly (bug introduced in 4.0 versions).
 4.0.8
	- Bug fix - after pressing "stop" and "write", the program crashed.
	Reported by Pat Siddharta. This was a bug previous to 4.0.0
 4.0.7
	- Changed biweekly into fortnightly (suggested by Tom Hosty).
	- Crash bug fix (when modifying an activity). This bug was introduced
	in the 4.0 series.
 4.0.6
	- Bug fix - when starting new rules, it does not crash anymore.
 4.0.5
	- After pressing Exit, the user can cancel exit.
	- Added a check if FET has write access on the local hard disk.
	- Now the institution name and comments windows are non-modal.
 4.0.4
	- Bug fix - updating the generation in timetable allocate menu works correctly
	(previously, it updated generation as 1, 3, 5, ...). This was solved by adding
	a QSemaphore condition in the allocation thread
 4.0.3
	- Bug fix - when erasing a year or group, removing now all corresponding constraints
	(even those referring to erased groups or subgroups). Crash bug fix - when removing
	a year which contained groups with constraints pointing to them (bug prior to 4.0.0)
	- Crash bug fix, when opening a file after another containing rooms
	(bug introduced in version 4.0.0)
 4.0.2
	- Changed the list of activities, buildings, equipments, rooms, space constraints,
	students years, students groups, students subgroups, subject, subject tag, teachers
	and time constraints to be QList, instead of Q3PtrList.
	- Small leakages fixed
	- Small bug fixes
 4.0.1
	- Various improvements
 4.0.0
	- Changed MY into MS (Malay language).
	- Improved the languages menu.
	- Improved Polish translation (by Radosław Pasiok).
	- Bug fix (when pressing the "Write results", FET crashed)
	- Began porting to Qt 4
	- Improved the threads code in the allocate menus
	- Made MAX_SUBGROUPS_PER_GROUP=100 (suggested by Andreas Goranson)
 3.18.1
	- Small bug fix.
 3.18.0
	- Added the possibility to export to iCalendar (suggested by Simon Bohlin).
 3.17.12
	- Began Dutch translation (by Niels Fikse).
 3.17.11
	- Improvement in conflicts reporting English language: instead of "this increases the
	conflicts factor with" we have "this increases the conflicts total by" (reported by
	Tom Hosty).
 3.17.10
	- Now saving the timetable both in days horizontal and days vertical versions in html files.
	(suggested by Tom Hosty).
 3.17.9
	- Bug fix: handling ampersand in the hmtl generated timetables (reported by Tom Hosty).
 3.17.8
	- Bug fix: renaming or deleting the "results" directory during program operation
	is now handled correctly (reported by Tom Hosty).
 3.17.7
	- Added Turkish translation (by Mehmet Gezmisoglu).
 3.17.6
	- Improvement: the interface now contains the constraints to minimize the number of
	rooms for students and for teachers.
	- Improved the sample number 9.
 3.17.5
	- Added a new sample, number 9 (sent by Cristian Gherman)
	- Now each generated timetable html file contains an ending tag, mentioning the date
	and the time the timetable was generated
 3.17.4
	- Improvement in Romanian translation (by Liviu Lalescu)
 3.17.3
	- Improvement in Polish translation (by Radosław Pasiok)
 3.17.2
	- Improvement in Polish translation (by Radosław Pasiok)
 3.17.1
	- Improved the saving in .html of the teachers' timetable (suggested
	by Sebastian O'Halloran).
 3.17.0
	- Small bug fixes.
	- The user can now select a list of active activities to build the schedule upon.
 3.16.9
	- Bug fix in ConstraintActivityPreferredTime (suggested by Yush Yuen).
	- The weight of the constraints can be 0 (suggested by Yush Yuen).
	- Liviu Lalescu, Polish translation by Radosław Pasiok,
	Turkish translation by Mehmet Gezmisoglu,
	Dutch translation by Niels Fikse.
 3.16.8
	- Improved AddConstraintActivitiesSameStartingTime dialog (suggested by Yush Yuen).
 3.16.7
	- Small interface bug fixes in ConstraintMaxRoomChangesPerDay add dialog and modify
	dialog (reported by Daan Huntjens).
 3.16.6
	- The activity can now contain maximum 100 teachers (suggested by Dragos Petrascu)
 3.16.5
	- The _studentstimetable2.html contains also the teachers (suggested by Daniel Schockett).
 3.16.4
	- Removed ConstraintMinimizeBuildingChangesForTeachers and ConstraintMinimizeBuildingChangesForStudents
	- Added ConstraintMaxRoomChangesPerDayForTeachers & ConstraintMaxRoomChangesPerDayForStudents
 3.16.3
	- Added ConstraintMinimizeNumberOfRoomsForTeachers (suggested by Dragos Petrascu)
	- Small bug fixes
 3.16.2
	- Added ConstraintMaxBuildingChangesPerDayForTeachers (suggested by Dragos Petrascu)
	- Added ConstraintMaxBuildingChangesPerDayForStudents (suggested by Dragos Petrascu)
 3.16.1
	- Added ConstraintMinimizeBuildingChangesForTeachers (suggested by Dragos Petrascu)
	- Added ConstraintMinimizeBuildingChangesForStudents (suggested by Dragos Petrascu)
 3.16.0
	- Added buildings
	- Added filters for rooms dialog
	- The rooms adding and modifying dialogs are improved
 3.15.4
	- Bug fix - the interface now only permits MAX_TEACHERS_PER_ACTIVITY (currently 6)
	for an activity.
 3.15.3
	- Time allocation now generates a .html file for students timetable ordered by
	students subgroup and days and hours.
 3.15.2
	- Added help files and help menu for constraints and constraints subtags (by Daniel S).
	- Added Constraint2ActivitiesOrdered (suggested by Gianluca Salvo).
 3.15.1
	- Clear buttons in AddActivity and ModifyActivity now work correctly.
 3.15.0
	- When adding or modifying an activity, the dialog contains a list box for teachers and
	students, allowing as many as needed (suggested by Dragos Petrascu).
	- Changes in the way of viewing the generated timetables (suggested by Scott Sweeting).
	- Bug fix: saving the timetables in html and xml corrected to handle special characters
	like <, >, & etc.
	- Added ConstraintTeacherSubjectRequireRoom (suggested by Scott Sweeting).
 3.14.21
	- Small bug fixes (when showing the conflicts, now the hours are shown properly).
	- Liviu Lalescu,
	- constraints and constraints subtags help files by Daniel S.
 3.14.20
	- Bug fix in modify constraint activities not overlapping and modify
	constraint min n days between activities.
 3.14.19
	- Bug fix (in ConstraintStudentsSetNotAvailable) - thanks to Daan Huntjens
	Corrected with the help of Valgrind.
 3.14.18
	- Updated Malay translation (by Abdul Hadi Kamel).
 3.14.17
	- Added Polish translation (by Radosław Pasiok).
 3.14.16
	- Bug fix (when viewing the timetable).
 3.14.15
	- Improved ConstraintActivitiesPreferredTimes, to include also a subject tag.
	- Bug fix in ConstraintActivitiesPreferredTimes.
	- Improvement when saving a ConstraintActivitiesPreferredTimes.
 3.14.14
	- Now, special characters <, >, ', " and & are handled correctly in names
	(bug reported by Frans de Bruijn)
	- Code readability improvement (instead of getXMLDescription, now it is getXmlDescription)
 3.14.13
	- Improved "Save as" dialog.
 3.14.12
	- Small bug fix and improvement in modify activity dialog
 3.14.11
	- Improved population size dialog.
	- Improved the name of 3 constraints
		(ConstraintTeachersNoMoreThanXHoursDaily is now ConstraintTeachersMaxHoursDaily,
		ConstraintTeachersNoMoreThanXHoursContinuously is now ConstraintTeachersMaxHoursContinuously and
		ConstraintTeachersSubgroupsNoMoreThanXHoursDaily is now ConstraintTeachersSubgroupsMaxHoursDaily)
 3.14.10
	- Small bug fix.
 3.14.9
	- MAX_YEARS is now 100.
	- Small improvement in the code.
 3.14.8
	- Bug fix (thanks to Sebastian Canagaratna).
 3.14.7
	- Added ConstraintTeachersSubjectTagMaxHoursContinuously (suggested
	by Abdul Hadi-Kamel).
	- Small bug fix.
 3.14.6
	- Added ConstraintTeachersSubjectTagsMaxHoursContinuously (suggested
	by Abdul Hadi-Kamel).
 3.14.5
	- Small bug fix (when showing related constraints for students sets).
 3.14.4
	- Now, the students sets, rooms and equipments forms show also the related constraints.
 3.14.3
	- Now, the subject tags form shows also the related constraints.
 3.14.2
	- When quitting, the save file message box has default on "Yes".
	- Now, the teachers and subjects form shows also the related constraints.
	- Various small bug-fixes.
 3.14.1
	- Bug fix.
 3.14.0
	- Now each activity's description includes the directly related constraints.
	(suggested by Abdul Hadi Kamel)
 3.13.8
	- Small bug fix (when adding a new ConstraintActivityPreferredTime).
	- Liviu Lalescu,
	- Polish translation by Radosław Pasiok,
	- Malay translation update by Abdul Hadi Kamel.
 3.13.7
	- Now the selected language has a check mark near it.
 3.13.6
	- Bug fix - memory leakage fixed.
 3.13.5
 3.13.4
	- Small improvement (the program does not crash anymore if there are more activities, constraints, etc.
	 than the maximum allowed).
 3.13.3
	- Possibility to fix only time or space (suggested by Abdul Hadi Kamel).
	- Small bug-fixes.
 3.13.2
	- Small bug fixes.
	- Added the possibility to lock activities when viewing the timetable (suggested by Abdul Hadi Kamel).
 3.13.1
	- Small improvement in speed.
 3.13.0
	- Added ConstraintSubjectSubjectTagPreferredRoom(s) and ConstraintSubjectPreferredRoom(s)
	(suggested by Abdul Hadi Kamel).
	- Improved the conflicts reporting for space constraints (now, it keeps track of
	the parity).
	- Various bug fixes.
 3.12.32
	- Added Malay translation (thanks to Abdul Hadi Kamel)
 3.12.31
	- The activities dialog now contains a subject tag filter
	- Important bug fixes in the constraints same starting time, same starting hour and same room
 3.12.30
	- Added Catalan translation (thanks to Miguel Gea Milvaques)
 3.12.29
	- Small bug-fixes
	- Added ConstraintActivitiesSameRoom and ConstraintActivityPreferredRooms (suggested
		by Sebastian Canagaratna)
 3.12.28
	- Small bug fix when renaming a year or group (reported by Hadi Kamel)
	- Bug fix when erasing activities
 3.12.27
	- Small improvement in the interface
 3.12.26
	- Small improvement in the interface
 3.12.25
	- The teachers' timetable now contains a subject tag
	- Bug fix - when the time constraints are invalid, the user is presented the problem
		- reported by Sebastian Canagaratna
 3.12.24
	- Small update in the FAQ
 3.12.23
	- Small improvement in the Romanian translation
	- Updated the French translation (Jerome Durand)
 3.12.22
	- Small improvements
 3.12.21
	- Small improvements
	- The language is now saved in the configuration file
 3.12.20
	- Small improvements and bug-fixes
 3.12.19
	- Small improvements in the interface
 3.12.18
	- Small bug fix
 3.12.17
	- Improved the Help/About form (included the sponsors tab)
	- Added a file named SPONSORS
	- Modified the file format (*.fet, and added a <!DOCTYPE FET> tag and so on)
	- Added the institution name and comments
 3.12.16
	- Small bug fixes in the interface
 3.12.15
	- Small bug fixes in the interface
 3.12.14
	- Modified the constraint subject requires equipments
	- Added ConstraintSubjectSubjectTagRequiresEquipments
 3.12.13
	- Bug fix (constraint subject requires equipments now works correctly)
	- Bug fix (reading activities)
 3.12.12
	- Small improvement in the Help/FAQ form
 3.12.11
	- Small improvement in the Help/About form
	- Bug fixes (subject tags)
 3.12.10
	- Small improvement in the Help/About form
 3.12.9
	- Modified the Help/About and Help/FAQ forms
 3.12.8
	- Improved Romanian translation (bug reported by Cristian Gherman)
 3.12.7
	- Small improvements in the interface
 3.12.6
	- Small bug fixes in the interface
 3.12.5
	- Bug fixes
 3.12.4
	- Added a field named "subject tag" (suggested by Abdul Hadi Kamel)
 3.12.3
	- Bug fixes
	- Added ConstraintActivitiesSameStartingHour (suggested by Sebastian Canagaratna)
 3.12.2
	- Bug fixes
 3.12.1
	- Improvements in the interface
 3.12.0
	- The user now has the possibility to choose only one phase allocation
	(for difficult space constraints)
 3.11.6
	- Improved Romanian translation
	French translation by Jerome Durand,
	Catalan translation by Miguel Gea Milvaques,
	Malay translation by Abdul Hadi Kamel.
 3.11.5
	- Bug-fixes
 3.11.4
	- Bug fixes (basic time & space constraints can now be non-compulsory)
	- Improved the interface (space constraints)
 3.11.3
	- Improvements in the interface (edit equipments, rooms)
	- Bug fixes (space constraints)
 3.11.2
	- Bug fixes
 3.11.1
	- Improved the interface (bug fix, improvements)
 3.11.0
	- Improved the interface - Data / time constraints
 3.10.5
	- Small bug fix in the interface
 3.10.4
	- Improvements in the interface (the user can now modify the information about
	the activities).
 3.10.3
	- Improvements in the interface (the user can now modify the information about
	the students).
 3.10.2
	- Improvements in space allocation (now compulsory ConstraintTeacherRequiresRoom
	works by repairing)
	- Added ConstraintActivityPreferredRoom (suggested by Sebastian Canagaratna)
 3.10.1
	- Bug fix - ConstraintMinimizeNumberOfRoomsForStudents is now showed correctly.
	- Small bug-fixes.
	- Improvements in the interface.
 3.10.0
	- Added ConstraintMinimizeNumberOfRoomsForStudents (suggested by Sebastian Canagaratna)
 3.9.23
	- The user can view the timetable (and saving to html works) for students and teachers
	showing also the rooms (suggested by Sebastian Canagaratna).
	- The space allocation is somewhat faster, by getting rid of the logging part and an
	unnecessary sorting.
 3.9.22
	- The internal state and the exported timetables are now saved in files named after the
	.xml input file, to allow multiple simulations (suggested by Sebastian Canagaratna).
	- Saving now the timetable in .xml and .html models (suggested by Cristian Gherman).
 3.9.21
	- The conflicts are now saved in a file ("time_conflicts.txt" and
	 "space_conflicts.txt") - suggested by Sebastian Canagaratna.
	- Now, saving the internal state works correctly in Debian - reported by
	Sebastian Canagaratna.
 3.9.20
	- Moved the directory "results" to "~/.fet/results"
 3.9.19
	- FET now can deal with translations installed in /usr/share/fet/translations/
	 (suggested by Radu Spineanu).
 3.9.18
	- fixed some compilation issues.
	- when reading activities with invalid subject, teacher or students, the program does not
	crash anymore (thanks to Morten Piil).
 3.9.17
	- small doc/FAQ and TODO files modifications.
	- small interface improvements.
 3.9.16
	- When viewing the timetable for teachers, shows also the subjects
	(suggested by Nicholas Robinson).
 3.9.15
	- Small bug fix when writing the default ini file
	- Small bug fix in the conflicts reporting section
 3.9.14
	- Small bug fix when writing the default ini file
 3.9.13
	- Now the fet.ini file is written in the home directory
 3.9.12
 3.9.11
	- Improved Romanian translation
 3.9.10
	- When exiting, the program asks to save the current file (suggested by Nicholas Robinson)
	- Added ConstraintTeacherRequiresRoom (suggested by Nicholas Robinson).
 3.9.9
	- Eliminated some "unused variable" compiler warnings.
	- Modified a bit the README file.
 3.9.8
	- The possibility to add more teachers pe activity (6), by working on the .xml file
	(suggested by Cristian Gherman).
	- Eliminated the old compatibility loading (file rules_compatibility.cpp).
 3.9.7
	- Bug corrected - the program now saves correctly the compulsory argument when working
	in another language (suggested by Cristian Gherman).
 3.9.6
	- Improved the Romanian translation and "Timetable/Export" menu.
 3.9.5
	- Improvement of the Help/About form.
 3.9.4
	- In the add activity dialog, added 3 check boxes so that the user can select only years,
	groups, subgroups or a combination of these.
 3.9.3
	- Bug fix in the add constraint activities same starting time dialog - reported by Ian Fantom
 3.9.2
	- ConstraintActivitiesSameStartingTime is now separate (in TimeConstraints2) and improved,
	that is you can schedule activities in similar blocks (suggested by Ian Fantom).
	- Small interface improvements.
 3.9.1
	- Small improvement in translations.
	- Small improvement in Help/About form.
	- Added 2 scripts in the "results/" directory to convert the xml results (Jerome Durand, Vimal Joseph).
 3.9.0
	- Bug fix - medium fitness now is shown correctly (no more negative values). Reported
	by Marek Jaszuk.
	- Added a file in the "doc/" directory, explaining how to add/improve translations.
	- Added Constraint2ActivitiesConsecutive (suggested by Ramanathan Srinivasan).
	- Added Constraint2ActivitiesGrouped (suggested by Ramanathan Srinivasan).
	- Added ConstraintActivitiesPreferredTimes (suggested by Vimal Joseph).
	- Modified a bit the organization of translations.
	- Added French translation (by Jerome Durand).
	- Bug fix in ConstraintSubjectRequiresEquipments (non-compulsory constraints
	were considered compulsory).
 3.8.5
	- Bug fix - when restoring the internal state (time or space), without previously saving
	the internal state, FET crashed (thanks to Marek Jaszuk)
	- Improved translation
	- Now you can write the timetable after initialization or loading the internal state,
	without starting the simulation
	2 conversion scripts by Jerome Durand and Vimal Joseph.
 3.8.4
	- Bug fix: Timetable->Allocate rooms->Start/Continue - crashed FET if there was no
	previous Initialization (thanks to Marek Jaszuk)
	- "Time constraint teacher max days per week broken for teacher:
	XY. This increases the conflicts factor with 0" (thanks to Marek Jaszuk)
 3.8.3
	- Doxygen options bug corrected
	- Eliminated some compiler warnings
 3.8.2
	- Bug fix when reading ConstraintRoomNotAvailable (thanks to Jerome Durand)
 3.8.1
	- Small bug fixes in the interface
 3.8.0
	- Added equipments list
	- Added ConstraintSubjectRequiresEquipment
	- Small bug fixes
 3.7.2
	- ConstraintTeacherMaxDaysPerWeek
	- small bug fix in the interface (when adding ConstraintStudentsSetIntervalMaxDaysPerWeek,
	the maximum number of days of the spin box is now updated correctly)
 3.7.1
	- Small bug fixes
 3.7.0
	- Added the number of students for each students set
	- The basic space constraints now include the requirement that each room's capacity
	must be greater or equal to the number of participating students
 3.6.7
	- Small bug fixes in the add activity dialog
 3.6.6
	- Saving of the timetable in xml format is now improved
 3.6.5
	- The days, hours and add activity dialog are now resizeable
 3.6.4
	- Small bug fixes in the interface
	- Improved add activity dialog
 3.6.3
	- Small bug fixes in the interface
 3.6.2
	- Small bug fixes in the interface
 3.6.1
	- Improved the days dialog
	- Improved the hours dialog and added names for the hours. The file structure
	was a bit changed, but you can open older files and save them as new ones.
 3.6.0
	- Each room is now represented by name, type and capacity
	- Added ConstraintRoomNotAvailable
	- Added ConstraintTeachersNoMoreThanXHoursDaily
	- Added ConstraintRoomTypeNotAllowedSubjects
 3.5.4
	- When viewing the timetable, it shows the subject for the students and the
	students for the teachers (suggested by Sajith V. K.)
 3.5.3
	- Bug fix - the maximum number of teachers is now 200, instead of 100 (thanks to
	Gibbon Tamba for reporting this potential bug)
 3.5.2
	- Bug fix in selecting the first or second best out of three chromosomes (3 tournament)
 3.5.1
	- Added an interface to ConstraintActivityPreferredTimes
 3.5.0
	- Added ConstraintActivityPreferredTimes (suggested by Michael Towers)
	- Added ConstraintStudentsSetIntervalMaxDaysPerWeek (suggested by Simon Getti)
	- Added ConstraintActivityEndsDay (suggested by Michael Towers)
 3.4.8
	- FET allows now to use two ConstraintMinNDaysBetweenActivities for the same activities
 3.4.7
	- Bug fix, crashing when logging ConstraintStudentsEarly
 3.4.6
	- The user can now modify the population number from the interface
	- The default population size is now 8192
 3.4.5
	- Addings in FAQ
	- Modified the parameters of the genetic algorithm and now FET can deal better
	with broken ConstraintNoGaps (students or teachers).
 3.4.4
	- Made the simulation somewhat faster, by avoiding an unnecessary sorting
	when the evolution method is three-tournament selection
 3.4.3
	- Small bug fix in ConstraintStudentsSetNHoursDaily (thanks to Michael Towers)
 3.4.2
	- Improvements in constraints names
	- New constraints
 3.4.1 (pre1 and pre2)
	- Improvements in constraints names
	- New constraints
 3.4.0 (pre1 and pre2)
	- Each activity supports several teachers (3, but this can be easily extended)
	- Now, the default population size is 2048 (Michael Towers's suggestion).
	- Bug fixes in ConstraintTeachersNoMoreThanXHoursContinuously
	- Changed ConstraintStudentsNotAvailable into ConstraintStudentsSetNotAvailable
		changed ConstraintActivitiesSameTime into ConstraintActivitiesSameStartingTime
		changed ConstraintActivitiesNotSameTime into ConstraintActivitiesNotOverlapping
		changed ConstraintStudentsNoWindows into ConstraintStudentsNoGaps
		changed ConstraintTeachersNoWindows into ConstraintTeachersNoGaps
		changed ConstraintStudentsNotTooMuch into ConstraintStudentsMaxDaysLength
 3.3.1
	- bug fix when reading ConstraintStudentsNotAvailable
 3.3.0
	- small bug fixes in the interface
 3.2.9
	- bug fix in ConstraintActivityPreferredTime (thanks to Michael Towers)
 3.2.8
	- Made the simulation faster (very little) by getting rid of the logging part
 3.2.7
	- Added a FAQ
 3.2.6
	- now, compulsory ConstraintActivityPreferredTime is implemented better
	(as a repairing of the choromosome).
	- improved speed by avoiding two passes through the internal constraints list
	when computing hard and soft fitness (compulsory or non-compulsory conflicts)
 3.2.5
	- small bug fix
	- improved internalization
	- improved Romanian translation
 3.2.4
	- began internalization (using qtranslator)
	- began Romanian translation
 3.2.3
	- corrected small bug in ConstraintActivitiesSameTime and
	ConstraintActivitiesNotSameTime
	- ConstraintActivitiesSameTime now works much better for compulsory constraints.
	I considered that it is better to repair each chromosome so that all
	the compulsory constraints of this type are fulfilled, before evaluating it.
	This change was suggested by an input data file from Ian Fantom,
	which contained a lot of this constraints and the old version was failing
	lamentably.
 3.2.2
	- fixed compilation issue
 3.2.0
	- changed the GUI: the user can see all constituent activities and constraints
	- saving now even basic constraints
	- the GUI now has filters when viewing constraints and activities
 3.1.4
	- improved (very little) ConstraintActivitiesNotSameDay
	- fixed activity bug: comparing 2 activities for equality now works
	- now the user can see whether the activities have daily exclusion or not
 3.1.3
	- fixed bug when reading ConstraintBreak
	- leak bug fixed, thanks to Valgrind (duplicated constraints were not deleted
	if Rules::addTimeConstraint returned false)
	- bug fix: adding/removing constraints and reading input files resets
	variable Rules::internalStructureComputed to false
	- corrected ConstraintStudentsEarly
 3.1.2
	- space (room) allocation (sigh of relief)
 3.1.1
	- improved speed (instead of 9 seconds, I get now 7 seconds on a test), by
	reducing redundant computations for teachers and students conflicts
 3.1.0
	- now the years and groups can have overlapping subgroups (uff)
	- the activities support more than one set of students (year, group or subgroup)
 3.0.0 pre4 - Liviu Lalescu
	- improved structure of the output xml files
	- began working at space allocation
 3.0.0 pre3 - Liviu Lalescu
	- improved speed by modifying a bit the fitness calculation.
 3.0.0 pre2 - Liviu Lalescu
	- subjects, teachers, students are now QPtrList.
	- the file open/saveas dialog now open in working directory
 3.0.0 pre1 - Liviu Lalescu
	- activities list is now a qt list (QPtrList)
	- constraints list is now a qt list (QPtrList)
	- bug fixes
	- max hours per week is now short integer (instead of char)
	- removed population initialization method from the ini file and added it
	into the GUI
	- made the simulation somewhat faster, by getting rid of function realTimes(i)
 2.10.0 - Liviu Lalescu
	- bug fixes (maybe added a few new ones :-)
	- FET now uses QString, QValueStack, QDomDocument, QFile and QTextStream classes
	 (Imre Nagy's suggestion).
 2.9.6 - bug fixes
 2.9.5 - bug fix, new activity is added with correct index
 2.9.4 - lots of bug fixes (thanks to Michael Towers)
 2.9.3 - bug fix when reading constraints (thanks to Michael Towers)
 2.9.2 - bug fix when reading constraints (thanks to Ian Fantom, Marc Falcon)
 2.9.1 - small crash bug fixed (when erasing a year and pressing Cancel)
	- added ConstraintActivitiesNotSameTime
 2.9.0 - bug fix in ConstraintStudentsYearNotAvailable
	- changed Restriction into Constraint, now you can implement any constraint
	as compulsory or not
 2.8.5 - changed the name to FET (or fet)
	- added break periods (with CHRBreak)
 2.8.4 - small changes in the interface.
 2.8.3 - bug fix - GUI restriction CHRTeacher(Year, Group, Subgroup)NotAvailable
	corrected, by enabling the day and hour.
 2.8.2 - added CHRActivitiesSameTime (idea by Sajith V. K., to handle activities
	having more teachers or more groups from different years. This can be done
	using dummy groups or dummy teachers).
	- increased the number of split activities to 8 in the GUI.
	- now, any unallocated activity has weight 10000.
 2.8.1 - bug fixes
 2.8.0 - bug fixes
	- added CSRActivityPreferredTime (user may specify for each activity a preferred
	time) - (suggested by Sajith V. K.)
 2.7.8 - small improvement in students view timetable form
	- now, the user can click on the table to see details about the activity
 2.7.7 - small bug fixes.
	- the main engine, interface and intermediate objects are now placed in separated directories
 2.7.6 - bug fix in load recorded position.
 2.7.5 - bug fixes in activities form.
 2.7.4 - improved the add custom hard restriction and add custom soft restriction dialogs;
	- allowing to split an activity in two ways: daily exclusion or no daily exclusion;
	- added CHRTeachersSubgroupsNoMoreThanXHoursDaily (no teacher can teach to a subgroup more than x hours daily) - to be checked thoroughly;
	- added the possibility to record a position of the simulation on the hard disk and the subsequent retrieval.
 2.7.3 - user can change the number of hours and days;
	- list of activities - fixed bug in the interface.
 2.7.2 - implemented menu item Timetable/Show(teachers) (shows the the timetable for a certain teacher).
 2.7.1 - added CHRTeachersNoMoreThanXHoursContinuously.
 2.7.0 - added CHRActivitiesNotSameDay;
	- added split activities (for high-schools);
	- changed numbering of the versions (Carsten Niehaus's suggestion).
 2.6 - crash bugs fixed.
 2.5 - crash bugs fixed.
 2.4 - made a separate list for subjects (not depending on teacher).
 2.3 - added conflicts reporting.
 2.2
 2.1
 2.0 and above - better Qt GUI.
 1.12 - used Valgrind to track down an annoying crashing bug. Thanks!
	This was not the only time I used Valgrind to hunt for bugs
 1.8 and above - removed the text menu :-)
 1.5 and above - added Qt GUI.
 1 and above - added text menu.
 0.1 - 0.57 - no user interface, plenty of bugs.
